# AdministrativeTasksApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteWorkspaceUsingDELETE**](AdministrativeTasksApi.md#deleteWorkspaceUsingDELETE) | **DELETE** /api/v1/admin/account | Delete a single workspace
[**exportWorkspaceUsingGET**](AdministrativeTasksApi.md#exportWorkspaceUsingGET) | **GET** /api/v1/admin/export | Export a single workspace
[**findWorkspaceFilesBySizeUsingGET**](AdministrativeTasksApi.md#findWorkspaceFilesBySizeUsingGET) | **GET** /api/v1/admin/usage/filesBySize | Retrieve workspace files by size
[**getWorkspaceQueryUsageUsingGET**](AdministrativeTasksApi.md#getWorkspaceQueryUsageUsingGET) | **GET** /api/v1/admin/usage/query | Retrieve workspace query usage
[**getWorkspaceUploadUsageUsingGET**](AdministrativeTasksApi.md#getWorkspaceUploadUsageUsingGET) | **GET** /api/v1/admin/usage/upload | Retrieve workspace upload usage
[**importDataUsingPOST**](AdministrativeTasksApi.md#importDataUsingPOST) | **POST** /api/v1/admin/import | Import data
[**validateFilesUsingPOST**](AdministrativeTasksApi.md#validateFilesUsingPOST) | **POST** /api/v1/admin/validation/files | Validate files
[**validateTablesUsingPOST**](AdministrativeTasksApi.md#validateTablesUsingPOST) | **POST** /api/v1/admin/validation/tables | Validate tables


<a name="deleteWorkspaceUsingDELETE"></a>
# **deleteWorkspaceUsingDELETE**
> BaseResponseOfstring deleteWorkspaceUsingDELETE()

Delete a single workspace

Deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone&lt;/b&gt;. Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
try {
    BaseResponseOfstring result = apiInstance.deleteWorkspaceUsingDELETE();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#deleteWorkspaceUsingDELETE");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="exportWorkspaceUsingGET"></a>
# **exportWorkspaceUsingGET**
> BaseResponseOfTokenDto exportWorkspaceUsingGET()

Export a single workspace

Creates a file representing the entirety of the requested workspace and returns a token. Use the [&#x60;Download a single file endpoint&#x60;](ref:wdata-downloadfileusingget) to exchange the token for the file.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
try {
    BaseResponseOfTokenDto result = apiInstance.exportWorkspaceUsingGET();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#exportWorkspaceUsingGET");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**BaseResponseOfTokenDto**](BaseResponseOfTokenDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="findWorkspaceFilesBySizeUsingGET"></a>
# **findWorkspaceFilesBySizeUsingGET**
> PagedResponseOfFileMetaDto findWorkspaceFilesBySizeUsingGET(limit, cursor, offset)

Retrieve workspace files by size

Returns a paged collection of the file meta associated with the workspace of the request, ordered by size.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
Integer limit = 56; // Integer | The number of file meta objects to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfFileMetaDto result = apiInstance.findWorkspaceFilesBySizeUsingGET(limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#findWorkspaceFilesBySizeUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **Integer**| The number of file meta objects to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfFileMetaDto**](PagedResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getWorkspaceQueryUsageUsingGET"></a>
# **getWorkspaceQueryUsageUsingGET**
> BaseResponseOflong getWorkspaceQueryUsageUsingGET(startDate, stopDate)

Retrieve workspace query usage

Returns a Long that represents the number of bytes queried by the workspace of the request since the start time provided.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
String startDate = "1970-01-01"; // String | The earliest date of usage to consider
String stopDate = "9999-01-01"; // String | The end date of usage to consider
try {
    BaseResponseOflong result = apiInstance.getWorkspaceQueryUsageUsingGET(startDate, stopDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#getWorkspaceQueryUsageUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **String**| The earliest date of usage to consider | [optional] [default to 1970-01-01]
 **stopDate** | **String**| The end date of usage to consider | [optional] [default to 9999-01-01]

### Return type

[**BaseResponseOflong**](BaseResponseOflong.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getWorkspaceUploadUsageUsingGET"></a>
# **getWorkspaceUploadUsageUsingGET**
> BaseResponseOflong getWorkspaceUploadUsageUsingGET(startDate, stopDate)

Retrieve workspace upload usage

Returns a Long that represents the number of bytes uploaded by the workspace associated with this request from the start time provided to now.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
String startDate = "1970-01-01"; // String | The starting point to begin considering usage
String stopDate = "9999-01-01"; // String | The ending point when considering usage
try {
    BaseResponseOflong result = apiInstance.getWorkspaceUploadUsageUsingGET(startDate, stopDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#getWorkspaceUploadUsageUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **String**| The starting point to begin considering usage | [optional] [default to 1970-01-01]
 **stopDate** | **String**| The ending point when considering usage | [optional] [default to 9999-01-01]

### Return type

[**BaseResponseOflong**](BaseResponseOflong.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="importDataUsingPOST"></a>
# **importDataUsingPOST**
> BaseResponseOfstring importDataUsingPOST(file, wipe)

Import data

By default, deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone.&lt;/b&gt;  Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes. After the delete, it then imports the tables, tags, and queries in the provided cb file into the workspace. &lt;br&gt;&lt;br&gt;This is an asynchronous operation. Returns a 201 when the file is correctly decoded and its tables, queries, and tags are saved. Files continue to import after this call completes.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
File file = new File("/path/to/file.txt"); // File | The file containing workspace information to import
Boolean wipe = true; // Boolean | wipe
try {
    BaseResponseOfstring result = apiInstance.importDataUsingPOST(file, wipe);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#importDataUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **file** | **File**| The file containing workspace information to import | [optional]
 **wipe** | **Boolean**| wipe | [optional] [default to true]

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

<a name="validateFilesUsingPOST"></a>
# **validateFilesUsingPOST**
> BaseResponseOfValidateFilesDto validateFilesUsingPOST(validateFilesDto)

Validate files

Validates files associated with the provided table ID. Validation repairs any files in an inconsistent state, and deletes those without enough state to recover. All files deleted or repaired are returned.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
StartValidateFilesDto validateFilesDto = new StartValidateFilesDto(); // StartValidateFilesDto | The representation of the file to validate
try {
    BaseResponseOfValidateFilesDto result = apiInstance.validateFilesUsingPOST(validateFilesDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#validateFilesUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **validateFilesDto** | [**StartValidateFilesDto**](StartValidateFilesDto.md)| The representation of the file to validate |

### Return type

[**BaseResponseOfValidateFilesDto**](BaseResponseOfValidateFilesDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="validateTablesUsingPOST"></a>
# **validateTablesUsingPOST**
> BaseResponseOfValidateTablesDto validateTablesUsingPOST()

Validate tables

Validates the tables in the workspace associated with the request. Validation returns an entity that indicates the tables deleted due to bad state, and those with enough state and repaired.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AdministrativeTasksApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

AdministrativeTasksApi apiInstance = new AdministrativeTasksApi();
try {
    BaseResponseOfValidateTablesDto result = apiInstance.validateTablesUsingPOST();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AdministrativeTasksApi#validateTablesUsingPOST");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**BaseResponseOfValidateTablesDto**](BaseResponseOfValidateTablesDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

