# ParameterManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createParameterUsingPOST**](ParameterManagementApi.md#createParameterUsingPOST) | **POST** /api/v1/parameter | Create parameter
[**deleteParameterUsingDELETE**](ParameterManagementApi.md#deleteParameterUsingDELETE) | **DELETE** /api/v1/parameter/{parameterId} | Delete Parameter
[**getParameterUsingGET**](ParameterManagementApi.md#getParameterUsingGET) | **GET** /api/v1/parameter/{parameterId} | Get Parameter
[**listParametersUsingGET**](ParameterManagementApi.md#listParametersUsingGET) | **GET** /api/v1/parameter | Get Parameters
[**updateParameterUsingPUT**](ParameterManagementApi.md#updateParameterUsingPUT) | **PUT** /api/v1/parameter/{parameterId} | Update Parameter


<a name="createParameterUsingPOST"></a>
# **createParameterUsingPOST**
> BaseResponseOfGlobalParameterDto createParameterUsingPOST(parameterDto)

Create parameter

Creates a parameter.  If there is a parameter with the same ID, a 409 is returned.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ParameterManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ParameterManagementApi apiInstance = new ParameterManagementApi();
GlobalParameterDto parameterDto = new GlobalParameterDto(); // GlobalParameterDto | The representation of the parameter to create
try {
    BaseResponseOfGlobalParameterDto result = apiInstance.createParameterUsingPOST(parameterDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ParameterManagementApi#createParameterUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterDto** | [**GlobalParameterDto**](GlobalParameterDto.md)| The representation of the parameter to create |

### Return type

[**BaseResponseOfGlobalParameterDto**](BaseResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteParameterUsingDELETE"></a>
# **deleteParameterUsingDELETE**
> BaseResponseOfstring deleteParameterUsingDELETE(parameterId)

Delete Parameter

Deletes the parameter with the provided parameter ID.  If the parameter is not found, this is a no-op.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ParameterManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ParameterManagementApi apiInstance = new ParameterManagementApi();
String parameterId = "parameterId_example"; // String | The unique identifier of the parameter
try {
    BaseResponseOfstring result = apiInstance.deleteParameterUsingDELETE(parameterId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ParameterManagementApi#deleteParameterUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterId** | **String**| The unique identifier of the parameter |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getParameterUsingGET"></a>
# **getParameterUsingGET**
> BaseResponseOfGlobalParameterDto getParameterUsingGET(parameterId)

Get Parameter

Returns a parameter matching the provided parameter ID.  If no matching entity can be found, a 404 status is returned.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ParameterManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ParameterManagementApi apiInstance = new ParameterManagementApi();
String parameterId = "parameterId_example"; // String | The unique identifier of the parameter
try {
    BaseResponseOfGlobalParameterDto result = apiInstance.getParameterUsingGET(parameterId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ParameterManagementApi#getParameterUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterId** | **String**| The unique identifier of the parameter |

### Return type

[**BaseResponseOfGlobalParameterDto**](BaseResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listParametersUsingGET"></a>
# **listParametersUsingGET**
> PagedResponseOfGlobalParameterDto listParametersUsingGET(limit, cursor, offset)

Get Parameters

Returns a list of all parameters associated with the workspace.  By default, these parameters are ordered by their names in ascending order.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ParameterManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ParameterManagementApi apiInstance = new ParameterManagementApi();
Integer limit = 56; // Integer | The number of parameters to return, must be between 1 and 1000, will default to 1000
String cursor = "cursor_example"; // String | A paging cursor; if included the limit is ignored
Long offset = 789L; // Long | The item to start with on the page, must be greater than or equal to 0, will default to 0
try {
    PagedResponseOfGlobalParameterDto result = apiInstance.listParametersUsingGET(limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ParameterManagementApi#listParametersUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **Integer**| The number of parameters to return, must be between 1 and 1000, will default to 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included the limit is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, must be greater than or equal to 0, will default to 0 | [optional]

### Return type

[**PagedResponseOfGlobalParameterDto**](PagedResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateParameterUsingPUT"></a>
# **updateParameterUsingPUT**
> BaseResponseOfGlobalParameterDto updateParameterUsingPUT(parameterId, parameterDto)

Update Parameter

Updates the parameter matching the provided ID in the provided payload.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ParameterManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ParameterManagementApi apiInstance = new ParameterManagementApi();
String parameterId = "parameterId_example"; // String | The unique identifier of the parameter
GlobalParameterDto parameterDto = new GlobalParameterDto(); // GlobalParameterDto | The representation of the parameter to update
try {
    BaseResponseOfGlobalParameterDto result = apiInstance.updateParameterUsingPUT(parameterId, parameterDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ParameterManagementApi#updateParameterUsingPUT");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterId** | **String**| The unique identifier of the parameter |
 **parameterDto** | [**GlobalParameterDto**](GlobalParameterDto.md)| The representation of the parameter to update |

### Return type

[**BaseResponseOfGlobalParameterDto**](BaseResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

