# SelectListManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createSelectListUsingPOST**](SelectListManagementApi.md#createSelectListUsingPOST) | **POST** /api/v1/selectlist | Create a new select list
[**deleteUsingDELETE**](SelectListManagementApi.md#deleteUsingDELETE) | **DELETE** /api/v1/selectlist/{selectListId} | Delete a single select list
[**getSelectListUsingGET**](SelectListManagementApi.md#getSelectListUsingGET) | **GET** /api/v1/selectlist/{selectListId} | Retrieve a single select list
[**listSelectListsUsingGET**](SelectListManagementApi.md#listSelectListsUsingGET) | **GET** /api/v1/selectlist | Retrieve a list of select lists
[**updateSelectListUsingPUT**](SelectListManagementApi.md#updateSelectListUsingPUT) | **PUT** /api/v1/selectlist/{selectListId} | Update a single select list


<a name="createSelectListUsingPOST"></a>
# **createSelectListUsingPOST**
> BaseResponseOfSelectListDto createSelectListUsingPOST(selectListDto)

Create a new select list

Creates a select list using the provided information and returns the select list meta.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SelectListManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SelectListManagementApi apiInstance = new SelectListManagementApi();
SelectListDto selectListDto = new SelectListDto(); // SelectListDto | The representation of the select list to create
try {
    BaseResponseOfSelectListDto result = apiInstance.createSelectListUsingPOST(selectListDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SelectListManagementApi#createSelectListUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListDto** | [**SelectListDto**](SelectListDto.md)| The representation of the select list to create |

### Return type

[**BaseResponseOfSelectListDto**](BaseResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteUsingDELETE"></a>
# **deleteUsingDELETE**
> BaseResponseOfstring deleteUsingDELETE(selectListId)

Delete a single select list

Deletes a select list with the provided ID. If no such select list exists, this is a no-op.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SelectListManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SelectListManagementApi apiInstance = new SelectListManagementApi();
String selectListId = "selectListId_example"; // String | The unique identifier of the select list
try {
    BaseResponseOfstring result = apiInstance.deleteUsingDELETE(selectListId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SelectListManagementApi#deleteUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListId** | **String**| The unique identifier of the select list |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getSelectListUsingGET"></a>
# **getSelectListUsingGET**
> BaseResponseOfSelectListDto getSelectListUsingGET(selectListId)

Retrieve a single select list

Returns a select list that matches the provided ID, or a 404 if no matching select list is found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SelectListManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SelectListManagementApi apiInstance = new SelectListManagementApi();
String selectListId = "selectListId_example"; // String | The unique identifier of the select list
try {
    BaseResponseOfSelectListDto result = apiInstance.getSelectListUsingGET(selectListId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SelectListManagementApi#getSelectListUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListId** | **String**| The unique identifier of the select list |

### Return type

[**BaseResponseOfSelectListDto**](BaseResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listSelectListsUsingGET"></a>
# **listSelectListsUsingGET**
> PagedResponseOfSelectListDto listSelectListsUsingGET(limit, cursor, offset)

Retrieve a list of select lists

Returns a list of select lists associated with the workspace.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SelectListManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SelectListManagementApi apiInstance = new SelectListManagementApi();
Integer limit = 56; // Integer | The number of select lists to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfSelectListDto result = apiInstance.listSelectListsUsingGET(limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SelectListManagementApi#listSelectListsUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **Integer**| The number of select lists to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfSelectListDto**](PagedResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSelectListUsingPUT"></a>
# **updateSelectListUsingPUT**
> BaseResponseOfSelectListDto updateSelectListUsingPUT(selectListDto, selectListId)

Update a single select list

Updates the select list with the provided ID with the details provided  in the body.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.SelectListManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

SelectListManagementApi apiInstance = new SelectListManagementApi();
SelectListDto selectListDto = new SelectListDto(); // SelectListDto | The representation of the select list to update
String selectListId = "selectListId_example"; // String | The unique identifier of the select list
try {
    BaseResponseOfSelectListDto result = apiInstance.updateSelectListUsingPUT(selectListDto, selectListId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SelectListManagementApi#updateSelectListUsingPUT");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListDto** | [**SelectListDto**](SelectListDto.md)| The representation of the select list to update |
 **selectListId** | **String**| The unique identifier of the select list |

### Return type

[**BaseResponseOfSelectListDto**](BaseResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

