# TokenManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createTokenUsingPOST**](TokenManagementApi.md#createTokenUsingPOST) | **POST** /api/v1/token | Create a new token
[**downloadFileUsingGET1**](TokenManagementApi.md#downloadFileUsingGET1) | **GET** /api/v1/token/{tokenId} | Download a single file


<a name="createTokenUsingPOST"></a>
# **createTokenUsingPOST**
> BaseResponseOfTokenDto createTokenUsingPOST(tokenDto)

Create a new token

Creates a temporary token—valid for only a short period of time—to download a table dataset file or query result, given its ID.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.TokenManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

TokenManagementApi apiInstance = new TokenManagementApi();
TokenDto tokenDto = new TokenDto(); // TokenDto | The representation of the token to update
try {
    BaseResponseOfTokenDto result = apiInstance.createTokenUsingPOST(tokenDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TokenManagementApi#createTokenUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tokenDto** | [**TokenDto**](TokenDto.md)| The representation of the token to update |

### Return type

[**BaseResponseOfTokenDto**](BaseResponseOfTokenDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="downloadFileUsingGET1"></a>
# **downloadFileUsingGET1**
> byte[] downloadFileUsingGET1(tokenId, filename)

Download a single file

Downloads a table dataset or query result as a file, given its token from the [&#x60;Create a new token endpoint&#x60;](ref:wdata-createtokenusingpost). If no matching entity is found, returns a 404.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.TokenManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

TokenManagementApi apiInstance = new TokenManagementApi();
String tokenId = "tokenId_example"; // String | The unique identifier of the token
String filename = "filename_example"; // String | A filename for the download; if included, the default filename is overridden
try {
    byte[] result = apiInstance.downloadFileUsingGET1(tokenId, filename);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TokenManagementApi#downloadFileUsingGET1");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tokenId** | **String**| The unique identifier of the token |
 **filename** | **String**| A filename for the download; if included, the default filename is overridden | [optional]

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

