# UtilitiesApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**parseDateUsingPOST**](UtilitiesApi.md#parseDateUsingPOST) | **POST** /api/v1/util/datetime | Parse a date


<a name="parseDateUsingPOST"></a>
# **parseDateUsingPOST**
> BaseResponseOfstring parseDateUsingPOST(datetimeDto)

Parse a date

Provides a simple endpoint to check whether a given date candidate parses with the provided format string.  Both the date candidate and format strings are required. Returns a 200 if the date parses, or a 400 with a message if not. If the date parses, the provided format can be provided as column metadata, and the imported values parse correctly. The format string is java DateTimeFormatter style e.g. dateFormat &#x3D; \&quot;MM/dd/yyyy\&quot; and candidate &#x3D; \&quot;07/28/1987\&quot;

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UtilitiesApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

UtilitiesApi apiInstance = new UtilitiesApi();
DatetimeDto datetimeDto = new DatetimeDto(); // DatetimeDto | The representation of the datetime object to parse
try {
    BaseResponseOfstring result = apiInstance.parseDateUsingPOST(datetimeDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UtilitiesApi#parseDateUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **datetimeDto** | [**DatetimeDto**](DatetimeDto.md)| The representation of the datetime object to parse |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

