/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.BaseResponseOfSpreadsheetInfoDto;
import io.swagger.client.model.ExportFileDto;
import io.swagger.client.model.PagedResponseOfImportErrorDto;
import io.swagger.client.model.BaseResponseOfFileMetaDto;
import io.swagger.client.model.PagedResponseOfFileMetaDto;
import java.io.File;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FileManagementApi {
    private ApiClient apiClient;

    public FileManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public FileManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for deleteFileUsingDELETE */
    private com.squareup.okhttp.Call deleteFileUsingDELETECall(String fileId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'fileId' is set
        if (fileId == null) {
            throw new ApiException("Missing the required parameter 'fileId' when calling deleteFileUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file/{fileId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "fileId" + "\\}", apiClient.escapeString(fileId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single file
     * Unstages the file with the provided ID. The file must have a STAGED status; if the file isn&#39;t STAGED, returns a 409 status. If the file isn&#39;t found, this is a no-op.
     * @param fileId The unique identifier of the file (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteFileUsingDELETE(String fileId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteFileUsingDELETEWithHttpInfo(fileId);
        return resp.getData();
    }

    /**
     * Delete a single file
     * Unstages the file with the provided ID. The file must have a STAGED status; if the file isn&#39;t STAGED, returns a 409 status. If the file isn&#39;t found, this is a no-op.
     * @param fileId The unique identifier of the file (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteFileUsingDELETEWithHttpInfo(String fileId) throws ApiException {
        com.squareup.okhttp.Call call = deleteFileUsingDELETECall(fileId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single file (asynchronously)
     * Unstages the file with the provided ID. The file must have a STAGED status; if the file isn&#39;t STAGED, returns a 409 status. If the file isn&#39;t found, this is a no-op.
     * @param fileId The unique identifier of the file (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteFileUsingDELETEAsync(String fileId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteFileUsingDELETECall(fileId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for downloadFileUsingGET */
    private com.squareup.okhttp.Call downloadFileUsingGETCall(String fileId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'fileId' is set
        if (fileId == null) {
            throw new ApiException("Missing the required parameter 'fileId' when calling downloadFileUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file/{fileId}/download".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "fileId" + "\\}", apiClient.escapeString(fileId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Download a single file
     * Returns a file with the provided ID, which points to a file meta ID.
     * @param fileId The unique identifier of the file (required)
     * @return byte[]
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public byte[] downloadFileUsingGET(String fileId) throws ApiException {
        ApiResponse<byte[]> resp = downloadFileUsingGETWithHttpInfo(fileId);
        return resp.getData();
    }

    /**
     * Download a single file
     * Returns a file with the provided ID, which points to a file meta ID.
     * @param fileId The unique identifier of the file (required)
     * @return ApiResponse&lt;byte[]&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<byte[]> downloadFileUsingGETWithHttpInfo(String fileId) throws ApiException {
        com.squareup.okhttp.Call call = downloadFileUsingGETCall(fileId, null, null);
        Type localVarReturnType = new TypeToken<byte[]>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Download a single file (asynchronously)
     * Returns a file with the provided ID, which points to a file meta ID.
     * @param fileId The unique identifier of the file (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call downloadFileUsingGETAsync(String fileId, final ApiCallback<byte[]> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = downloadFileUsingGETCall(fileId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<byte[]>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for exportFileToSpreadsheetsUsingPOST */
    private com.squareup.okhttp.Call exportFileToSpreadsheetsUsingPOSTCall(String fileId, ExportFileDto exportFileDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = exportFileDto;
        
        // verify the required parameter 'fileId' is set
        if (fileId == null) {
            throw new ApiException("Missing the required parameter 'fileId' when calling exportFileToSpreadsheetsUsingPOST(Async)");
        }
        
        // verify the required parameter 'exportFileDto' is set
        if (exportFileDto == null) {
            throw new ApiException("Missing the required parameter 'exportFileDto' when calling exportFileToSpreadsheetsUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file/{fileId}/export".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "fileId" + "\\}", apiClient.escapeString(fileId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Export a file to spreadsheets
     * Exports the file ID identified in the path to the spreadsheet identified by the provided URL. If the URL string is empty, creates and returns a new spreadsheet and its sheet IDs.
     * @param fileId The unique identifier of the file (required)
     * @param exportFileDto The representation of the file to export (required)
     * @return BaseResponseOfSpreadsheetInfoDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfSpreadsheetInfoDto exportFileToSpreadsheetsUsingPOST(String fileId, ExportFileDto exportFileDto) throws ApiException {
        ApiResponse<BaseResponseOfSpreadsheetInfoDto> resp = exportFileToSpreadsheetsUsingPOSTWithHttpInfo(fileId, exportFileDto);
        return resp.getData();
    }

    /**
     * Export a file to spreadsheets
     * Exports the file ID identified in the path to the spreadsheet identified by the provided URL. If the URL string is empty, creates and returns a new spreadsheet and its sheet IDs.
     * @param fileId The unique identifier of the file (required)
     * @param exportFileDto The representation of the file to export (required)
     * @return ApiResponse&lt;BaseResponseOfSpreadsheetInfoDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfSpreadsheetInfoDto> exportFileToSpreadsheetsUsingPOSTWithHttpInfo(String fileId, ExportFileDto exportFileDto) throws ApiException {
        com.squareup.okhttp.Call call = exportFileToSpreadsheetsUsingPOSTCall(fileId, exportFileDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfSpreadsheetInfoDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Export a file to spreadsheets (asynchronously)
     * Exports the file ID identified in the path to the spreadsheet identified by the provided URL. If the URL string is empty, creates and returns a new spreadsheet and its sheet IDs.
     * @param fileId The unique identifier of the file (required)
     * @param exportFileDto The representation of the file to export (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call exportFileToSpreadsheetsUsingPOSTAsync(String fileId, ExportFileDto exportFileDto, final ApiCallback<BaseResponseOfSpreadsheetInfoDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = exportFileToSpreadsheetsUsingPOSTCall(fileId, exportFileDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfSpreadsheetInfoDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getErrorsUsingGET */
    private com.squareup.okhttp.Call getErrorsUsingGETCall(String fileId, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'fileId' is set
        if (fileId == null) {
            throw new ApiException("Missing the required parameter 'fileId' when calling getErrorsUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file/{fileId}/error".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "fileId" + "\\}", apiClient.escapeString(fileId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve errors
     * Returns a paged list of operation errors during the upload, import, or tagging processes for the provided file ID, if they exist. This list is immutable and may be empty if no errors have occurred. If errors exist we recommend fixing them and reimporting your file
     * @param fileId The unique identifier of the file (required)
     * @param limit The number of errors to return, from 1 to 50; by default, 50 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfImportErrorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfImportErrorDto getErrorsUsingGET(String fileId, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfImportErrorDto> resp = getErrorsUsingGETWithHttpInfo(fileId, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve errors
     * Returns a paged list of operation errors during the upload, import, or tagging processes for the provided file ID, if they exist. This list is immutable and may be empty if no errors have occurred. If errors exist we recommend fixing them and reimporting your file
     * @param fileId The unique identifier of the file (required)
     * @param limit The number of errors to return, from 1 to 50; by default, 50 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfImportErrorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfImportErrorDto> getErrorsUsingGETWithHttpInfo(String fileId, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = getErrorsUsingGETCall(fileId, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfImportErrorDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve errors (asynchronously)
     * Returns a paged list of operation errors during the upload, import, or tagging processes for the provided file ID, if they exist. This list is immutable and may be empty if no errors have occurred. If errors exist we recommend fixing them and reimporting your file
     * @param fileId The unique identifier of the file (required)
     * @param limit The number of errors to return, from 1 to 50; by default, 50 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getErrorsUsingGETAsync(String fileId, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfImportErrorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getErrorsUsingGETCall(fileId, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfImportErrorDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getFileUsingGET */
    private com.squareup.okhttp.Call getFileUsingGETCall(String fileId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'fileId' is set
        if (fileId == null) {
            throw new ApiException("Missing the required parameter 'fileId' when calling getFileUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file/{fileId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "fileId" + "\\}", apiClient.escapeString(fileId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a single file
     * Returns the file meta that matches the provided ID, or a 404 if an associated file can&#39;t be found.
     * @param fileId The unique identifier of the file (required)
     * @return BaseResponseOfFileMetaDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFileMetaDto getFileUsingGET(String fileId) throws ApiException {
        ApiResponse<BaseResponseOfFileMetaDto> resp = getFileUsingGETWithHttpInfo(fileId);
        return resp.getData();
    }

    /**
     * Retrieve a single file
     * Returns the file meta that matches the provided ID, or a 404 if an associated file can&#39;t be found.
     * @param fileId The unique identifier of the file (required)
     * @return ApiResponse&lt;BaseResponseOfFileMetaDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFileMetaDto> getFileUsingGETWithHttpInfo(String fileId) throws ApiException {
        com.squareup.okhttp.Call call = getFileUsingGETCall(fileId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a single file (asynchronously)
     * Returns the file meta that matches the provided ID, or a 404 if an associated file can&#39;t be found.
     * @param fileId The unique identifier of the file (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFileUsingGETAsync(String fileId, final ApiCallback<BaseResponseOfFileMetaDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFileUsingGETCall(fileId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getFilesUsingGET */
    private com.squareup.okhttp.Call getFilesUsingGETCall(String tableId, Integer limit, String cursor, Long offset, String sortOrder, String sortBy, String searchText, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling getFilesUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (tableId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "tableId", tableId));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));
        if (sortOrder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sortOrder", sortOrder));
        if (sortBy != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sortBy", sortBy));
        if (searchText != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "searchText", searchText));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of files
     * Returns a paged list of all files associated with the provided table ID, as well as metadata associated with each file.
     * @param tableId The unique table identifier associated with this file (required)
     * @param limit The number of files to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param sortOrder The sort order for the files being returned (optional)
     * @param sortBy The column to use the sort order on (optional)
     * @param searchText The text to filter the results upon; matching the file name (optional)
     * @return PagedResponseOfFileMetaDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfFileMetaDto getFilesUsingGET(String tableId, Integer limit, String cursor, Long offset, String sortOrder, String sortBy, String searchText) throws ApiException {
        ApiResponse<PagedResponseOfFileMetaDto> resp = getFilesUsingGETWithHttpInfo(tableId, limit, cursor, offset, sortOrder, sortBy, searchText);
        return resp.getData();
    }

    /**
     * Retrieve a list of files
     * Returns a paged list of all files associated with the provided table ID, as well as metadata associated with each file.
     * @param tableId The unique table identifier associated with this file (required)
     * @param limit The number of files to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param sortOrder The sort order for the files being returned (optional)
     * @param sortBy The column to use the sort order on (optional)
     * @param searchText The text to filter the results upon; matching the file name (optional)
     * @return ApiResponse&lt;PagedResponseOfFileMetaDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfFileMetaDto> getFilesUsingGETWithHttpInfo(String tableId, Integer limit, String cursor, Long offset, String sortOrder, String sortBy, String searchText) throws ApiException {
        com.squareup.okhttp.Call call = getFilesUsingGETCall(tableId, limit, cursor, offset, sortOrder, sortBy, searchText, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfFileMetaDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of files (asynchronously)
     * Returns a paged list of all files associated with the provided table ID, as well as metadata associated with each file.
     * @param tableId The unique table identifier associated with this file (required)
     * @param limit The number of files to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param sortOrder The sort order for the files being returned (optional)
     * @param sortBy The column to use the sort order on (optional)
     * @param searchText The text to filter the results upon; matching the file name (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFilesUsingGETAsync(String tableId, Integer limit, String cursor, Long offset, String sortOrder, String sortBy, String searchText, final ApiCallback<PagedResponseOfFileMetaDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFilesUsingGETCall(tableId, limit, cursor, offset, sortOrder, sortBy, searchText, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfFileMetaDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for uploadFileUsingPOST */
    private com.squareup.okhttp.Call uploadFileUsingPOSTCall(String tableId, File file, String name, String url, String source, String delimiter, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling uploadFileUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (file != null)
        localVarFormParams.put("file", file);
        if (tableId != null)
        localVarFormParams.put("tableId", tableId);
        if (name != null)
        localVarFormParams.put("name", name);
        if (url != null)
        localVarFormParams.put("url", url);
        if (source != null)
        localVarFormParams.put("source", source);
        if (delimiter != null)
        localVarFormParams.put("delimiter", delimiter);

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Upload a single file
     * Accepts CSV, TSV, or JSON files, or a ZIP file that contains a single CSV, TSV, or JSON file. If a ZIP, it must contain a CSV, TSV, or JSON file, and the name of the CSV, TSV, or JSON file is also used with the imported file. Downloading this file again downloads the source. Note that all files uploaded must have a .csv, .tsv, or .json extension. JSON files are expected to have a single JSON record per line; a JSON file is a series of JSON objects delimited by a newline character.
     * @param tableId The unique table identifier associated with this file (required)
     * @param file The physical file to upload (optional)
     * @param name No longer in use, here to ensure backwards compatibility (optional)
     * @param url No longer in use, here to ensure backwards compatibility (optional)
     * @param source The data source to associate with the file, no more than 255 characters. This field is not in use; it only keeps track of the source (optional)
     * @param delimiter The character to use as a delimiter within the file to separate one field from another.  The default is comma (optional)
     * @return BaseResponseOfFileMetaDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFileMetaDto uploadFileUsingPOST(String tableId, File file, String name, String url, String source, String delimiter) throws ApiException {
        ApiResponse<BaseResponseOfFileMetaDto> resp = uploadFileUsingPOSTWithHttpInfo(tableId, file, name, url, source, delimiter);
        return resp.getData();
    }

    /**
     * Upload a single file
     * Accepts CSV, TSV, or JSON files, or a ZIP file that contains a single CSV, TSV, or JSON file. If a ZIP, it must contain a CSV, TSV, or JSON file, and the name of the CSV, TSV, or JSON file is also used with the imported file. Downloading this file again downloads the source. Note that all files uploaded must have a .csv, .tsv, or .json extension. JSON files are expected to have a single JSON record per line; a JSON file is a series of JSON objects delimited by a newline character.
     * @param tableId The unique table identifier associated with this file (required)
     * @param file The physical file to upload (optional)
     * @param name No longer in use, here to ensure backwards compatibility (optional)
     * @param url No longer in use, here to ensure backwards compatibility (optional)
     * @param source The data source to associate with the file, no more than 255 characters. This field is not in use; it only keeps track of the source (optional)
     * @param delimiter The character to use as a delimiter within the file to separate one field from another.  The default is comma (optional)
     * @return ApiResponse&lt;BaseResponseOfFileMetaDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFileMetaDto> uploadFileUsingPOSTWithHttpInfo(String tableId, File file, String name, String url, String source, String delimiter) throws ApiException {
        com.squareup.okhttp.Call call = uploadFileUsingPOSTCall(tableId, file, name, url, source, delimiter, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Upload a single file (asynchronously)
     * Accepts CSV, TSV, or JSON files, or a ZIP file that contains a single CSV, TSV, or JSON file. If a ZIP, it must contain a CSV, TSV, or JSON file, and the name of the CSV, TSV, or JSON file is also used with the imported file. Downloading this file again downloads the source. Note that all files uploaded must have a .csv, .tsv, or .json extension. JSON files are expected to have a single JSON record per line; a JSON file is a series of JSON objects delimited by a newline character.
     * @param tableId The unique table identifier associated with this file (required)
     * @param file The physical file to upload (optional)
     * @param name No longer in use, here to ensure backwards compatibility (optional)
     * @param url No longer in use, here to ensure backwards compatibility (optional)
     * @param source The data source to associate with the file, no more than 255 characters. This field is not in use; it only keeps track of the source (optional)
     * @param delimiter The character to use as a delimiter within the file to separate one field from another.  The default is comma (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call uploadFileUsingPOSTAsync(String tableId, File file, String name, String url, String source, String delimiter, final ApiCallback<BaseResponseOfFileMetaDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = uploadFileUsingPOSTCall(tableId, file, name, url, source, delimiter, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for validateFilenameUsingGET */
    private com.squareup.okhttp.Call validateFilenameUsingGETCall(String tableId, String filename, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling validateFilenameUsingGET(Async)");
        }
        
        // verify the required parameter 'filename' is set
        if (filename == null) {
            throw new ApiException("Missing the required parameter 'filename' when calling validateFilenameUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/file/validateName".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (tableId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "tableId", tableId));
        if (filename != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "filename", filename));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Validate whether a file with the filename can be uploaded to the table
     * If the filename is valid, this returns 200. If the table already has a file with the same name, this returns 409. If the user isn&#39;t allowed to read the table, or if the table isn&#39;t found, this returns 404.
     * @param tableId The ID of the table to upload the file to (required)
     * @param filename The name of the file to upload (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring validateFilenameUsingGET(String tableId, String filename) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = validateFilenameUsingGETWithHttpInfo(tableId, filename);
        return resp.getData();
    }

    /**
     * Validate whether a file with the filename can be uploaded to the table
     * If the filename is valid, this returns 200. If the table already has a file with the same name, this returns 409. If the user isn&#39;t allowed to read the table, or if the table isn&#39;t found, this returns 404.
     * @param tableId The ID of the table to upload the file to (required)
     * @param filename The name of the file to upload (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> validateFilenameUsingGETWithHttpInfo(String tableId, String filename) throws ApiException {
        com.squareup.okhttp.Call call = validateFilenameUsingGETCall(tableId, filename, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Validate whether a file with the filename can be uploaded to the table (asynchronously)
     * If the filename is valid, this returns 200. If the table already has a file with the same name, this returns 409. If the user isn&#39;t allowed to read the table, or if the table isn&#39;t found, this returns 404.
     * @param tableId The ID of the table to upload the file to (required)
     * @param filename The name of the file to upload (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call validateFilenameUsingGETAsync(String tableId, String filename, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = validateFilenameUsingGETCall(tableId, filename, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
