/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.BaseResponseOfGlobalParameterDto;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.GlobalParameterDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.PagedResponseOfGlobalParameterDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ParameterManagementApi {
    private ApiClient apiClient;

    public ParameterManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ParameterManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for createParameterUsingPOST */
    private com.squareup.okhttp.Call createParameterUsingPOSTCall(GlobalParameterDto parameterDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = parameterDto;
        
        // verify the required parameter 'parameterDto' is set
        if (parameterDto == null) {
            throw new ApiException("Missing the required parameter 'parameterDto' when calling createParameterUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/parameter".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Create parameter
     * Creates a parameter.  If there is a parameter with the same ID, a 409 is returned.
     * @param parameterDto The representation of the parameter to create (required)
     * @return BaseResponseOfGlobalParameterDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfGlobalParameterDto createParameterUsingPOST(GlobalParameterDto parameterDto) throws ApiException {
        ApiResponse<BaseResponseOfGlobalParameterDto> resp = createParameterUsingPOSTWithHttpInfo(parameterDto);
        return resp.getData();
    }

    /**
     * Create parameter
     * Creates a parameter.  If there is a parameter with the same ID, a 409 is returned.
     * @param parameterDto The representation of the parameter to create (required)
     * @return ApiResponse&lt;BaseResponseOfGlobalParameterDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfGlobalParameterDto> createParameterUsingPOSTWithHttpInfo(GlobalParameterDto parameterDto) throws ApiException {
        com.squareup.okhttp.Call call = createParameterUsingPOSTCall(parameterDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfGlobalParameterDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create parameter (asynchronously)
     * Creates a parameter.  If there is a parameter with the same ID, a 409 is returned.
     * @param parameterDto The representation of the parameter to create (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createParameterUsingPOSTAsync(GlobalParameterDto parameterDto, final ApiCallback<BaseResponseOfGlobalParameterDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createParameterUsingPOSTCall(parameterDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfGlobalParameterDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for deleteParameterUsingDELETE */
    private com.squareup.okhttp.Call deleteParameterUsingDELETECall(String parameterId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'parameterId' is set
        if (parameterId == null) {
            throw new ApiException("Missing the required parameter 'parameterId' when calling deleteParameterUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/parameter/{parameterId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "parameterId" + "\\}", apiClient.escapeString(parameterId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete Parameter
     * Deletes the parameter with the provided parameter ID.  If the parameter is not found, this is a no-op.
     * @param parameterId The unique identifier of the parameter (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteParameterUsingDELETE(String parameterId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteParameterUsingDELETEWithHttpInfo(parameterId);
        return resp.getData();
    }

    /**
     * Delete Parameter
     * Deletes the parameter with the provided parameter ID.  If the parameter is not found, this is a no-op.
     * @param parameterId The unique identifier of the parameter (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteParameterUsingDELETEWithHttpInfo(String parameterId) throws ApiException {
        com.squareup.okhttp.Call call = deleteParameterUsingDELETECall(parameterId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete Parameter (asynchronously)
     * Deletes the parameter with the provided parameter ID.  If the parameter is not found, this is a no-op.
     * @param parameterId The unique identifier of the parameter (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteParameterUsingDELETEAsync(String parameterId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteParameterUsingDELETECall(parameterId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getParameterUsingGET */
    private com.squareup.okhttp.Call getParameterUsingGETCall(String parameterId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'parameterId' is set
        if (parameterId == null) {
            throw new ApiException("Missing the required parameter 'parameterId' when calling getParameterUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/parameter/{parameterId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "parameterId" + "\\}", apiClient.escapeString(parameterId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Get Parameter
     * Returns a parameter matching the provided parameter ID.  If no matching entity can be found, a 404 status is returned.
     * @param parameterId The unique identifier of the parameter (required)
     * @return BaseResponseOfGlobalParameterDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfGlobalParameterDto getParameterUsingGET(String parameterId) throws ApiException {
        ApiResponse<BaseResponseOfGlobalParameterDto> resp = getParameterUsingGETWithHttpInfo(parameterId);
        return resp.getData();
    }

    /**
     * Get Parameter
     * Returns a parameter matching the provided parameter ID.  If no matching entity can be found, a 404 status is returned.
     * @param parameterId The unique identifier of the parameter (required)
     * @return ApiResponse&lt;BaseResponseOfGlobalParameterDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfGlobalParameterDto> getParameterUsingGETWithHttpInfo(String parameterId) throws ApiException {
        com.squareup.okhttp.Call call = getParameterUsingGETCall(parameterId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfGlobalParameterDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Parameter (asynchronously)
     * Returns a parameter matching the provided parameter ID.  If no matching entity can be found, a 404 status is returned.
     * @param parameterId The unique identifier of the parameter (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getParameterUsingGETAsync(String parameterId, final ApiCallback<BaseResponseOfGlobalParameterDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getParameterUsingGETCall(parameterId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfGlobalParameterDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listParametersUsingGET */
    private com.squareup.okhttp.Call listParametersUsingGETCall(Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/parameter".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Get Parameters
     * Returns a list of all parameters associated with the workspace.  By default, these parameters are ordered by their names in ascending order.
     * @param limit The number of parameters to return, must be between 1 and 1000, will default to 1000 (optional)
     * @param cursor A paging cursor; if included the limit is ignored (optional)
     * @param offset The item to start with on the page, must be greater than or equal to 0, will default to 0 (optional)
     * @return PagedResponseOfGlobalParameterDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfGlobalParameterDto listParametersUsingGET(Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfGlobalParameterDto> resp = listParametersUsingGETWithHttpInfo(limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Get Parameters
     * Returns a list of all parameters associated with the workspace.  By default, these parameters are ordered by their names in ascending order.
     * @param limit The number of parameters to return, must be between 1 and 1000, will default to 1000 (optional)
     * @param cursor A paging cursor; if included the limit is ignored (optional)
     * @param offset The item to start with on the page, must be greater than or equal to 0, will default to 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfGlobalParameterDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfGlobalParameterDto> listParametersUsingGETWithHttpInfo(Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listParametersUsingGETCall(limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfGlobalParameterDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Parameters (asynchronously)
     * Returns a list of all parameters associated with the workspace.  By default, these parameters are ordered by their names in ascending order.
     * @param limit The number of parameters to return, must be between 1 and 1000, will default to 1000 (optional)
     * @param cursor A paging cursor; if included the limit is ignored (optional)
     * @param offset The item to start with on the page, must be greater than or equal to 0, will default to 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listParametersUsingGETAsync(Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfGlobalParameterDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listParametersUsingGETCall(limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfGlobalParameterDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for updateParameterUsingPUT */
    private com.squareup.okhttp.Call updateParameterUsingPUTCall(String parameterId, GlobalParameterDto parameterDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = parameterDto;
        
        // verify the required parameter 'parameterId' is set
        if (parameterId == null) {
            throw new ApiException("Missing the required parameter 'parameterId' when calling updateParameterUsingPUT(Async)");
        }
        
        // verify the required parameter 'parameterDto' is set
        if (parameterDto == null) {
            throw new ApiException("Missing the required parameter 'parameterDto' when calling updateParameterUsingPUT(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/parameter/{parameterId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "parameterId" + "\\}", apiClient.escapeString(parameterId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Update Parameter
     * Updates the parameter matching the provided ID in the provided payload.
     * @param parameterId The unique identifier of the parameter (required)
     * @param parameterDto The representation of the parameter to update (required)
     * @return BaseResponseOfGlobalParameterDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfGlobalParameterDto updateParameterUsingPUT(String parameterId, GlobalParameterDto parameterDto) throws ApiException {
        ApiResponse<BaseResponseOfGlobalParameterDto> resp = updateParameterUsingPUTWithHttpInfo(parameterId, parameterDto);
        return resp.getData();
    }

    /**
     * Update Parameter
     * Updates the parameter matching the provided ID in the provided payload.
     * @param parameterId The unique identifier of the parameter (required)
     * @param parameterDto The representation of the parameter to update (required)
     * @return ApiResponse&lt;BaseResponseOfGlobalParameterDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfGlobalParameterDto> updateParameterUsingPUTWithHttpInfo(String parameterId, GlobalParameterDto parameterDto) throws ApiException {
        com.squareup.okhttp.Call call = updateParameterUsingPUTCall(parameterId, parameterDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfGlobalParameterDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update Parameter (asynchronously)
     * Updates the parameter matching the provided ID in the provided payload.
     * @param parameterId The unique identifier of the parameter (required)
     * @param parameterDto The representation of the parameter to update (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateParameterUsingPUTAsync(String parameterId, GlobalParameterDto parameterDto, final ApiCallback<BaseResponseOfGlobalParameterDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateParameterUsingPUTCall(parameterId, parameterDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfGlobalParameterDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
