/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.TableDto;
import io.swagger.client.model.BaseResponseOfTableDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.PagedResponseOfQueryDto;
import io.swagger.client.model.BaseResponseOfImportInfoDto;
import io.swagger.client.model.PagedResponseOfTableDto;
import io.swagger.client.model.ImportDto;
import io.swagger.client.model.BaseResponseOfFileMetaDto;
import io.swagger.client.model.ImportFromSpreadsheetDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TableManagementApi {
    private ApiClient apiClient;

    public TableManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TableManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for createTableUsingPOST */
    private com.squareup.okhttp.Call createTableUsingPOSTCall(TableDto body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createTableUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Create a new table
     * Creates a table in the database with the specified schema. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.
     * @param body The representation of the table to create (required)
     * @return BaseResponseOfTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfTableDto createTableUsingPOST(TableDto body) throws ApiException {
        ApiResponse<BaseResponseOfTableDto> resp = createTableUsingPOSTWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Create a new table
     * Creates a table in the database with the specified schema. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.
     * @param body The representation of the table to create (required)
     * @return ApiResponse&lt;BaseResponseOfTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfTableDto> createTableUsingPOSTWithHttpInfo(TableDto body) throws ApiException {
        com.squareup.okhttp.Call call = createTableUsingPOSTCall(body, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new table (asynchronously)
     * Creates a table in the database with the specified schema. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.
     * @param body The representation of the table to create (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createTableUsingPOSTAsync(TableDto body, final ApiCallback<BaseResponseOfTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createTableUsingPOSTCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for deleteTableUsingDELETE */
    private com.squareup.okhttp.Call deleteTableUsingDELETECall(String tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling deleteTableUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single table
     * Soft-deletes the table with the provided ID.
     * @param tableId The unique identifier of the table (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteTableUsingDELETE(String tableId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteTableUsingDELETEWithHttpInfo(tableId);
        return resp.getData();
    }

    /**
     * Delete a single table
     * Soft-deletes the table with the provided ID.
     * @param tableId The unique identifier of the table (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteTableUsingDELETEWithHttpInfo(String tableId) throws ApiException {
        com.squareup.okhttp.Call call = deleteTableUsingDELETECall(tableId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single table (asynchronously)
     * Soft-deletes the table with the provided ID.
     * @param tableId The unique identifier of the table (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteTableUsingDELETEAsync(String tableId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteTableUsingDELETECall(tableId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getDependentsUsingGET */
    private com.squareup.okhttp.Call getDependentsUsingGETCall(String tableId, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling getDependentsUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}/dependents".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of dependents
     * Returns a list of all queries that use the table with provided ID as a datasource. If a shared table, this may include queries outside of the current OAuth context.  Permission is checked only for the table ID provided, _not_ on the returned list of queries.
     * @param tableId The unique identifier of the table (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfQueryDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfQueryDto getDependentsUsingGET(String tableId, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfQueryDto> resp = getDependentsUsingGETWithHttpInfo(tableId, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of dependents
     * Returns a list of all queries that use the table with provided ID as a datasource. If a shared table, this may include queries outside of the current OAuth context.  Permission is checked only for the table ID provided, _not_ on the returned list of queries.
     * @param tableId The unique identifier of the table (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfQueryDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfQueryDto> getDependentsUsingGETWithHttpInfo(String tableId, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = getDependentsUsingGETCall(tableId, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfQueryDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of dependents (asynchronously)
     * Returns a list of all queries that use the table with provided ID as a datasource. If a shared table, this may include queries outside of the current OAuth context.  Permission is checked only for the table ID provided, _not_ on the returned list of queries.
     * @param tableId The unique identifier of the table (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getDependentsUsingGETAsync(String tableId, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfQueryDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getDependentsUsingGETCall(tableId, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfQueryDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getImportInfoUsingGET */
    private com.squareup.okhttp.Call getImportInfoUsingGETCall(String tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling getImportInfoUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}/importInfo".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve import information
     * Returns information around imported files for a table.
     * @param tableId The unique identifier of the table (required)
     * @return BaseResponseOfImportInfoDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfImportInfoDto getImportInfoUsingGET(String tableId) throws ApiException {
        ApiResponse<BaseResponseOfImportInfoDto> resp = getImportInfoUsingGETWithHttpInfo(tableId);
        return resp.getData();
    }

    /**
     * Retrieve import information
     * Returns information around imported files for a table.
     * @param tableId The unique identifier of the table (required)
     * @return ApiResponse&lt;BaseResponseOfImportInfoDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfImportInfoDto> getImportInfoUsingGETWithHttpInfo(String tableId) throws ApiException {
        com.squareup.okhttp.Call call = getImportInfoUsingGETCall(tableId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfImportInfoDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve import information (asynchronously)
     * Returns information around imported files for a table.
     * @param tableId The unique identifier of the table (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getImportInfoUsingGETAsync(String tableId, final ApiCallback<BaseResponseOfImportInfoDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getImportInfoUsingGETCall(tableId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfImportInfoDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getTableUsingGET */
    private com.squareup.okhttp.Call getTableUsingGETCall(String tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling getTableUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a single table
     * Returns a table with the provided ID, or a 404 if no such table is found.
     * @param tableId The unique identifier of the table (required)
     * @return BaseResponseOfTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfTableDto getTableUsingGET(String tableId) throws ApiException {
        ApiResponse<BaseResponseOfTableDto> resp = getTableUsingGETWithHttpInfo(tableId);
        return resp.getData();
    }

    /**
     * Retrieve a single table
     * Returns a table with the provided ID, or a 404 if no such table is found.
     * @param tableId The unique identifier of the table (required)
     * @return ApiResponse&lt;BaseResponseOfTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfTableDto> getTableUsingGETWithHttpInfo(String tableId) throws ApiException {
        com.squareup.okhttp.Call call = getTableUsingGETCall(tableId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a single table (asynchronously)
     * Returns a table with the provided ID, or a 404 if no such table is found.
     * @param tableId The unique identifier of the table (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getTableUsingGETAsync(String tableId, final ApiCallback<BaseResponseOfTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getTableUsingGETCall(tableId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getTablesUsingGET */
    private com.squareup.okhttp.Call getTablesUsingGETCall(Boolean includeShared, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/table".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (includeShared != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "includeShared", includeShared));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of tables
     * Returns all tables available in the workspace.
     * @param includeShared If true, returns all tables shared with the workspace associated with the request. If false, returns only tables the workspace owns. (optional, default to false)
     * @param limit the number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor a paging cursor; if included the limit is ignored (optional)
     * @param offset The item to start with on the page, must be greater than or equal to 0, will default to 0 (optional)
     * @return PagedResponseOfTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfTableDto getTablesUsingGET(Boolean includeShared, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfTableDto> resp = getTablesUsingGETWithHttpInfo(includeShared, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of tables
     * Returns all tables available in the workspace.
     * @param includeShared If true, returns all tables shared with the workspace associated with the request. If false, returns only tables the workspace owns. (optional, default to false)
     * @param limit the number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor a paging cursor; if included the limit is ignored (optional)
     * @param offset The item to start with on the page, must be greater than or equal to 0, will default to 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfTableDto> getTablesUsingGETWithHttpInfo(Boolean includeShared, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = getTablesUsingGETCall(includeShared, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of tables (asynchronously)
     * Returns all tables available in the workspace.
     * @param includeShared If true, returns all tables shared with the workspace associated with the request. If false, returns only tables the workspace owns. (optional, default to false)
     * @param limit the number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor a paging cursor; if included the limit is ignored (optional)
     * @param offset The item to start with on the page, must be greater than or equal to 0, will default to 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getTablesUsingGETAsync(Boolean includeShared, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getTablesUsingGETCall(includeShared, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for importFileUsingPOST */
    private com.squareup.okhttp.Call importFileUsingPOSTCall(String tableId, ImportDto importDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = importDto;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling importFileUsingPOST(Async)");
        }
        
        // verify the required parameter 'importDto' is set
        if (importDto == null) {
            throw new ApiException("Missing the required parameter 'importDto' when calling importFileUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}/import".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Import a single file
     * Imports the provided file into the associated table, and immediately returns a file meta object with an ID that can be used to poll the file controller for status.
     * @param tableId The unique identifier of the table (required)
     * @param importDto The representation of the table to import (required)
     * @return BaseResponseOfFileMetaDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFileMetaDto importFileUsingPOST(String tableId, ImportDto importDto) throws ApiException {
        ApiResponse<BaseResponseOfFileMetaDto> resp = importFileUsingPOSTWithHttpInfo(tableId, importDto);
        return resp.getData();
    }

    /**
     * Import a single file
     * Imports the provided file into the associated table, and immediately returns a file meta object with an ID that can be used to poll the file controller for status.
     * @param tableId The unique identifier of the table (required)
     * @param importDto The representation of the table to import (required)
     * @return ApiResponse&lt;BaseResponseOfFileMetaDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFileMetaDto> importFileUsingPOSTWithHttpInfo(String tableId, ImportDto importDto) throws ApiException {
        com.squareup.okhttp.Call call = importFileUsingPOSTCall(tableId, importDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Import a single file (asynchronously)
     * Imports the provided file into the associated table, and immediately returns a file meta object with an ID that can be used to poll the file controller for status.
     * @param tableId The unique identifier of the table (required)
     * @param importDto The representation of the table to import (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call importFileUsingPOSTAsync(String tableId, ImportDto importDto, final ApiCallback<BaseResponseOfFileMetaDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = importFileUsingPOSTCall(tableId, importDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for importFromSpreadsheetsUsingPOST */
    private com.squareup.okhttp.Call importFromSpreadsheetsUsingPOSTCall(String tableId, ImportFromSpreadsheetDto importFromSpreadsheetDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = importFromSpreadsheetDto;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling importFromSpreadsheetsUsingPOST(Async)");
        }
        
        // verify the required parameter 'importFromSpreadsheetDto' is set
        if (importFromSpreadsheetDto == null) {
            throw new ApiException("Missing the required parameter 'importFromSpreadsheetDto' when calling importFromSpreadsheetsUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}/spreadsheet/import".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Import from spreadsheets
     * Imports spreadsheet data and immediately returns a file meta result. This DTO has an ID, which can be used to poll on status via the file controller.
     * @param tableId The unique identifier of the table (required)
     * @param importFromSpreadsheetDto The representation of the table to update (required)
     * @return BaseResponseOfFileMetaDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFileMetaDto importFromSpreadsheetsUsingPOST(String tableId, ImportFromSpreadsheetDto importFromSpreadsheetDto) throws ApiException {
        ApiResponse<BaseResponseOfFileMetaDto> resp = importFromSpreadsheetsUsingPOSTWithHttpInfo(tableId, importFromSpreadsheetDto);
        return resp.getData();
    }

    /**
     * Import from spreadsheets
     * Imports spreadsheet data and immediately returns a file meta result. This DTO has an ID, which can be used to poll on status via the file controller.
     * @param tableId The unique identifier of the table (required)
     * @param importFromSpreadsheetDto The representation of the table to update (required)
     * @return ApiResponse&lt;BaseResponseOfFileMetaDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFileMetaDto> importFromSpreadsheetsUsingPOSTWithHttpInfo(String tableId, ImportFromSpreadsheetDto importFromSpreadsheetDto) throws ApiException {
        com.squareup.okhttp.Call call = importFromSpreadsheetsUsingPOSTCall(tableId, importFromSpreadsheetDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Import from spreadsheets (asynchronously)
     * Imports spreadsheet data and immediately returns a file meta result. This DTO has an ID, which can be used to poll on status via the file controller.
     * @param tableId The unique identifier of the table (required)
     * @param importFromSpreadsheetDto The representation of the table to update (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call importFromSpreadsheetsUsingPOSTAsync(String tableId, ImportFromSpreadsheetDto importFromSpreadsheetDto, final ApiCallback<BaseResponseOfFileMetaDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = importFromSpreadsheetsUsingPOSTCall(tableId, importFromSpreadsheetDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for unimportFileUsingDELETE */
    private com.squareup.okhttp.Call unimportFileUsingDELETECall(String tableId, String fileId, String force, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling unimportFileUsingDELETE(Async)");
        }
        
        // verify the required parameter 'fileId' is set
        if (fileId == null) {
            throw new ApiException("Missing the required parameter 'fileId' when calling unimportFileUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}/import/{fileId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()))
        .replaceAll("\\{" + "fileId" + "\\}", apiClient.escapeString(fileId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (force != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "force", force));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Unimport a single file
     * Unimports the provided file from the provided table. Returns a 409 if the file is not in an imported state, or a 404 if the file can&#39;t be found.
     * @param tableId The unique identifier of the table (required)
     * @param fileId The unique identifier of the file (required)
     * @param force If true, unimports and deletes file from the table (optional, default to false)
     * @return BaseResponseOfFileMetaDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFileMetaDto unimportFileUsingDELETE(String tableId, String fileId, String force) throws ApiException {
        ApiResponse<BaseResponseOfFileMetaDto> resp = unimportFileUsingDELETEWithHttpInfo(tableId, fileId, force);
        return resp.getData();
    }

    /**
     * Unimport a single file
     * Unimports the provided file from the provided table. Returns a 409 if the file is not in an imported state, or a 404 if the file can&#39;t be found.
     * @param tableId The unique identifier of the table (required)
     * @param fileId The unique identifier of the file (required)
     * @param force If true, unimports and deletes file from the table (optional, default to false)
     * @return ApiResponse&lt;BaseResponseOfFileMetaDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFileMetaDto> unimportFileUsingDELETEWithHttpInfo(String tableId, String fileId, String force) throws ApiException {
        com.squareup.okhttp.Call call = unimportFileUsingDELETECall(tableId, fileId, force, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Unimport a single file (asynchronously)
     * Unimports the provided file from the provided table. Returns a 409 if the file is not in an imported state, or a 404 if the file can&#39;t be found.
     * @param tableId The unique identifier of the table (required)
     * @param fileId The unique identifier of the file (required)
     * @param force If true, unimports and deletes file from the table (optional, default to false)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call unimportFileUsingDELETEAsync(String tableId, String fileId, String force, final ApiCallback<BaseResponseOfFileMetaDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = unimportFileUsingDELETECall(tableId, fileId, force, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFileMetaDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for updateTableUsingPUT */
    private com.squareup.okhttp.Call updateTableUsingPUTCall(TableDto tableDto, String tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = tableDto;
        
        // verify the required parameter 'tableDto' is set
        if (tableDto == null) {
            throw new ApiException("Missing the required parameter 'tableDto' when calling updateTableUsingPUT(Async)");
        }
        
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling updateTableUsingPUT(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/table/{tableId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Update a single table
     * Updates an existing table with the provided information. Include all user-defined table columns with the request. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.  * If the table has no imported data, user-defined columns not included with the request are deleted, and columns are sorted according to their order in the request.  * If the table has imported data, any columns with names not already in the table are considered new. This equality check is case-insensitive. Any new columns appear after other user-defined columns, but before any meta columns, which start with &#x60;_&#x60;.
     * @param tableDto The representation of the table to update (required)
     * @param tableId The unique identifier of the table (required)
     * @return BaseResponseOfTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfTableDto updateTableUsingPUT(TableDto tableDto, String tableId) throws ApiException {
        ApiResponse<BaseResponseOfTableDto> resp = updateTableUsingPUTWithHttpInfo(tableDto, tableId);
        return resp.getData();
    }

    /**
     * Update a single table
     * Updates an existing table with the provided information. Include all user-defined table columns with the request. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.  * If the table has no imported data, user-defined columns not included with the request are deleted, and columns are sorted according to their order in the request.  * If the table has imported data, any columns with names not already in the table are considered new. This equality check is case-insensitive. Any new columns appear after other user-defined columns, but before any meta columns, which start with &#x60;_&#x60;.
     * @param tableDto The representation of the table to update (required)
     * @param tableId The unique identifier of the table (required)
     * @return ApiResponse&lt;BaseResponseOfTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfTableDto> updateTableUsingPUTWithHttpInfo(TableDto tableDto, String tableId) throws ApiException {
        com.squareup.okhttp.Call call = updateTableUsingPUTCall(tableDto, tableId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update a single table (asynchronously)
     * Updates an existing table with the provided information. Include all user-defined table columns with the request. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.  * If the table has no imported data, user-defined columns not included with the request are deleted, and columns are sorted according to their order in the request.  * If the table has imported data, any columns with names not already in the table are considered new. This equality check is case-insensitive. Any new columns appear after other user-defined columns, but before any meta columns, which start with &#x60;_&#x60;.
     * @param tableDto The representation of the table to update (required)
     * @param tableId The unique identifier of the table (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateTableUsingPUTAsync(TableDto tableDto, String tableId, final ApiCallback<BaseResponseOfTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateTableUsingPUTCall(tableDto, tableId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
