/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.joda.time.DateTime;


/**
 * ConnectionDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class ConnectionDto   {
  @SerializedName("connectionId")
  private String connectionId = null;

  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("createdBy")
  private String createdBy = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("destinationId")
  private String destinationId = null;

  /**
   * The type of file or item the connection sends data to
   */
  public enum DestinationTypeEnum {
    @SerializedName("spreadsheet")
    SPREADSHEET("spreadsheet"),
    
    @SerializedName("spreadsheet_section")
    SPREADSHEET_SECTION("spreadsheet_section"),
    
    @SerializedName("presentation")
    PRESENTATION("presentation"),
    
    @SerializedName("presentation_chart")
    PRESENTATION_CHART("presentation_chart"),
    
    @SerializedName("presentation_embedded_table")
    PRESENTATION_EMBEDDED_TABLE("presentation_embedded_table"),
    
    @SerializedName("document")
    DOCUMENT("document"),
    
    @SerializedName("document_chart")
    DOCUMENT_CHART("document_chart"),
    
    @SerializedName("document_embedded_table")
    DOCUMENT_EMBEDDED_TABLE("document_embedded_table"),
    
    @SerializedName("wdata_query")
    WDATA_QUERY("wdata_query"),
    
    @SerializedName("wdata_table")
    WDATA_TABLE("wdata_table"),
    
    @SerializedName("wdata_table_dataset")
    WDATA_TABLE_DATASET("wdata_table_dataset"),
    
    @SerializedName("report")
    REPORT("report"),
    
    @SerializedName("unknown_record_type")
    UNKNOWN_RECORD_TYPE("unknown_record_type");

    private String value;

    DestinationTypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("destinationType")
  private DestinationTypeEnum destinationType = null;

  @SerializedName("destinationWorkspaceId")
  private String destinationWorkspaceId = null;

  @SerializedName("lastRunBy")
  private String lastRunBy = null;

  @SerializedName("lastRunDate")
  private DateTime lastRunDate = null;

  @SerializedName("lastRunDestinationParameters")
  private Map<String, Object> lastRunDestinationParameters = new HashMap<String, Object>();

  @SerializedName("lastRunJobId")
  private String lastRunJobId = null;

  @SerializedName("lastRunSourceParameters")
  private Map<String, Object> lastRunSourceParameters = new HashMap<String, Object>();

  @SerializedName("metadata")
  private Map<String, Object> metadata = new HashMap<String, Object>();

  @SerializedName("name")
  private String name = null;

  @SerializedName("sourceId")
  private String sourceId = null;

  /**
   * The type of file or item the connection pulls data from
   */
  public enum SourceTypeEnum {
    @SerializedName("spreadsheet")
    SPREADSHEET("spreadsheet"),
    
    @SerializedName("spreadsheet_section")
    SPREADSHEET_SECTION("spreadsheet_section"),
    
    @SerializedName("presentation")
    PRESENTATION("presentation"),
    
    @SerializedName("presentation_chart")
    PRESENTATION_CHART("presentation_chart"),
    
    @SerializedName("presentation_embedded_table")
    PRESENTATION_EMBEDDED_TABLE("presentation_embedded_table"),
    
    @SerializedName("document")
    DOCUMENT("document"),
    
    @SerializedName("document_chart")
    DOCUMENT_CHART("document_chart"),
    
    @SerializedName("document_embedded_table")
    DOCUMENT_EMBEDDED_TABLE("document_embedded_table"),
    
    @SerializedName("wdata_query")
    WDATA_QUERY("wdata_query"),
    
    @SerializedName("wdata_table")
    WDATA_TABLE("wdata_table"),
    
    @SerializedName("wdata_table_dataset")
    WDATA_TABLE_DATASET("wdata_table_dataset"),
    
    @SerializedName("report")
    REPORT("report"),
    
    @SerializedName("unknown_record_type")
    UNKNOWN_RECORD_TYPE("unknown_record_type");

    private String value;

    SourceTypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("sourceType")
  private SourceTypeEnum sourceType = null;

  @SerializedName("sourceWorkspaceId")
  private String sourceWorkspaceId = null;

   /**
   * The unique ID of the connection
   * @return connectionId
  **/
  @ApiModelProperty(example = "null", value = "The unique ID of the connection")
  public String getConnectionId() {
    return connectionId;
  }

   /**
   * When the connection was created, as a datetime
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the connection was created, as a datetime")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The ID of the user that created the connection
   * @return createdBy
  **/
  @ApiModelProperty(example = "null", value = "The ID of the user that created the connection")
  public String getCreatedBy() {
    return createdBy;
  }

   /**
   * The description of the connection, if specified
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "The description of the connection, if specified")
  public String getDescription() {
    return description;
  }

   /**
   * The ID of the file or item the connection sends data to
   * @return destinationId
  **/
  @ApiModelProperty(example = "null", value = "The ID of the file or item the connection sends data to")
  public String getDestinationId() {
    return destinationId;
  }

   /**
   * The type of file or item the connection sends data to
   * @return destinationType
  **/
  @ApiModelProperty(example = "null", value = "The type of file or item the connection sends data to")
  public DestinationTypeEnum getDestinationType() {
    return destinationType;
  }

   /**
   * The workspace of the file or item the connection pulls data to
   * @return destinationWorkspaceId
  **/
  @ApiModelProperty(example = "null", value = "The workspace of the file or item the connection pulls data to")
  public String getDestinationWorkspaceId() {
    return destinationWorkspaceId;
  }

   /**
   * The ID of the user that last ran the connection
   * @return lastRunBy
  **/
  @ApiModelProperty(example = "null", value = "The ID of the user that last ran the connection")
  public String getLastRunBy() {
    return lastRunBy;
  }

   /**
   * When the connection last ran, as a datetime
   * @return lastRunDate
  **/
  @ApiModelProperty(example = "null", value = "When the connection last ran, as a datetime")
  public DateTime getLastRunDate() {
    return lastRunDate;
  }

  public ConnectionDto lastRunDestinationParameters(Map<String, Object> lastRunDestinationParameters) {
    this.lastRunDestinationParameters = lastRunDestinationParameters;
    return this;
  }

  public ConnectionDto putLastRunDestinationParametersItem(String key, Object lastRunDestinationParametersItem) {
    this.lastRunDestinationParameters.put(key, lastRunDestinationParametersItem);
    return this;
  }

   /**
   * A map of the parameters used with the destination when the connection last ran
   * @return lastRunDestinationParameters
  **/
  @ApiModelProperty(example = "null", value = "A map of the parameters used with the destination when the connection last ran")
  public Map<String, Object> getLastRunDestinationParameters() {
    return lastRunDestinationParameters;
  }

  public void setLastRunDestinationParameters(Map<String, Object> lastRunDestinationParameters) {
    this.lastRunDestinationParameters = lastRunDestinationParameters;
  }

   /**
   * The ID of the connection's last run
   * @return lastRunJobId
  **/
  @ApiModelProperty(example = "null", value = "The ID of the connection's last run")
  public String getLastRunJobId() {
    return lastRunJobId;
  }

  public ConnectionDto lastRunSourceParameters(Map<String, Object> lastRunSourceParameters) {
    this.lastRunSourceParameters = lastRunSourceParameters;
    return this;
  }

  public ConnectionDto putLastRunSourceParametersItem(String key, Object lastRunSourceParametersItem) {
    this.lastRunSourceParameters.put(key, lastRunSourceParametersItem);
    return this;
  }

   /**
   * A map of the parameters used with the source when the connection last ran
   * @return lastRunSourceParameters
  **/
  @ApiModelProperty(example = "null", value = "A map of the parameters used with the source when the connection last ran")
  public Map<String, Object> getLastRunSourceParameters() {
    return lastRunSourceParameters;
  }

  public void setLastRunSourceParameters(Map<String, Object> lastRunSourceParameters) {
    this.lastRunSourceParameters = lastRunSourceParameters;
  }

  public ConnectionDto metadata(Map<String, Object> metadata) {
    this.metadata = metadata;
    return this;
  }

  public ConnectionDto putMetadataItem(String key, Object metadataItem) {
    this.metadata.put(key, metadataItem);
    return this;
  }

   /**
   * Any additional information about the connection
   * @return metadata
  **/
  @ApiModelProperty(example = "null", value = "Any additional information about the connection")
  public Map<String, Object> getMetadata() {
    return metadata;
  }

  public void setMetadata(Map<String, Object> metadata) {
    this.metadata = metadata;
  }

   /**
   * The name of the connection, if specified
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the connection, if specified")
  public String getName() {
    return name;
  }

   /**
   * The ID of the file or item the connection pulls data from
   * @return sourceId
  **/
  @ApiModelProperty(example = "null", value = "The ID of the file or item the connection pulls data from")
  public String getSourceId() {
    return sourceId;
  }

   /**
   * The type of file or item the connection pulls data from
   * @return sourceType
  **/
  @ApiModelProperty(example = "null", value = "The type of file or item the connection pulls data from")
  public SourceTypeEnum getSourceType() {
    return sourceType;
  }

   /**
   * The workspace of the file or item the connection pulls data from
   * @return sourceWorkspaceId
  **/
  @ApiModelProperty(example = "null", value = "The workspace of the file or item the connection pulls data from")
  public String getSourceWorkspaceId() {
    return sourceWorkspaceId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ConnectionDto connectionDto = (ConnectionDto) o;
    return Objects.equals(this.connectionId, connectionDto.connectionId) &&
        Objects.equals(this.created, connectionDto.created) &&
        Objects.equals(this.createdBy, connectionDto.createdBy) &&
        Objects.equals(this.description, connectionDto.description) &&
        Objects.equals(this.destinationId, connectionDto.destinationId) &&
        Objects.equals(this.destinationType, connectionDto.destinationType) &&
        Objects.equals(this.destinationWorkspaceId, connectionDto.destinationWorkspaceId) &&
        Objects.equals(this.lastRunBy, connectionDto.lastRunBy) &&
        Objects.equals(this.lastRunDate, connectionDto.lastRunDate) &&
        Objects.equals(this.lastRunDestinationParameters, connectionDto.lastRunDestinationParameters) &&
        Objects.equals(this.lastRunJobId, connectionDto.lastRunJobId) &&
        Objects.equals(this.lastRunSourceParameters, connectionDto.lastRunSourceParameters) &&
        Objects.equals(this.metadata, connectionDto.metadata) &&
        Objects.equals(this.name, connectionDto.name) &&
        Objects.equals(this.sourceId, connectionDto.sourceId) &&
        Objects.equals(this.sourceType, connectionDto.sourceType) &&
        Objects.equals(this.sourceWorkspaceId, connectionDto.sourceWorkspaceId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(connectionId, created, createdBy, description, destinationId, destinationType, destinationWorkspaceId, lastRunBy, lastRunDate, lastRunDestinationParameters, lastRunJobId, lastRunSourceParameters, metadata, name, sourceId, sourceType, sourceWorkspaceId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ConnectionDto {\n");
    
    sb.append("    connectionId: ").append(toIndentedString(connectionId)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    createdBy: ").append(toIndentedString(createdBy)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    destinationId: ").append(toIndentedString(destinationId)).append("\n");
    sb.append("    destinationType: ").append(toIndentedString(destinationType)).append("\n");
    sb.append("    destinationWorkspaceId: ").append(toIndentedString(destinationWorkspaceId)).append("\n");
    sb.append("    lastRunBy: ").append(toIndentedString(lastRunBy)).append("\n");
    sb.append("    lastRunDate: ").append(toIndentedString(lastRunDate)).append("\n");
    sb.append("    lastRunDestinationParameters: ").append(toIndentedString(lastRunDestinationParameters)).append("\n");
    sb.append("    lastRunJobId: ").append(toIndentedString(lastRunJobId)).append("\n");
    sb.append("    lastRunSourceParameters: ").append(toIndentedString(lastRunSourceParameters)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    sourceId: ").append(toIndentedString(sourceId)).append("\n");
    sb.append("    sourceType: ").append(toIndentedString(sourceType)).append("\n");
    sb.append("    sourceWorkspaceId: ").append(toIndentedString(sourceWorkspaceId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

