/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * ExportQueryResultDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class ExportQueryResultDto   {
  @SerializedName("exportAsDataset")
  private Boolean exportAsDataset = null;

  @SerializedName("url")
  private String url = null;

  @SerializedName("useFlatKey")
  private Boolean useFlatKey = null;

  public ExportQueryResultDto exportAsDataset(Boolean exportAsDataset) {
    this.exportAsDataset = exportAsDataset;
    return this;
  }

   /**
   * If set to true, the data will be exported as a connected dataset to spreadsheets.
   * @return exportAsDataset
  **/
  @ApiModelProperty(example = "false", value = "If set to true, the data will be exported as a connected dataset to spreadsheets.")
  public Boolean getExportAsDataset() {
    return exportAsDataset;
  }

  public void setExportAsDataset(Boolean exportAsDataset) {
    this.exportAsDataset = exportAsDataset;
  }

  public ExportQueryResultDto url(String url) {
    this.url = url;
    return this;
  }

   /**
   * URL of the spreadsheet to export to, if present. If not present, a new spreadsheet will be created.
   * @return url
  **/
  @ApiModelProperty(example = "null", value = "URL of the spreadsheet to export to, if present. If not present, a new spreadsheet will be created.")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public ExportQueryResultDto useFlatKey(Boolean useFlatKey) {
    this.useFlatKey = useFlatKey;
    return this;
  }

   /**
   * Export flat query results in the context of crosstab queries; Ignored unless true.
   * @return useFlatKey
  **/
  @ApiModelProperty(example = "false", value = "Export flat query results in the context of crosstab queries; Ignored unless true.")
  public Boolean getUseFlatKey() {
    return useFlatKey;
  }

  public void setUseFlatKey(Boolean useFlatKey) {
    this.useFlatKey = useFlatKey;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ExportQueryResultDto exportQueryResultDto = (ExportQueryResultDto) o;
    return Objects.equals(this.exportAsDataset, exportQueryResultDto.exportAsDataset) &&
        Objects.equals(this.url, exportQueryResultDto.url) &&
        Objects.equals(this.useFlatKey, exportQueryResultDto.useFlatKey);
  }

  @Override
  public int hashCode() {
    return Objects.hash(exportAsDataset, url, useFlatKey);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ExportQueryResultDto {\n");
    
    sb.append("    exportAsDataset: ").append(toIndentedString(exportAsDataset)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    useFlatKey: ").append(toIndentedString(useFlatKey)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

