/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.joda.time.DateTime;


/**
 * FolderDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class FolderDto   {
  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("parentId")
  private String parentId = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

  public FolderDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * A description of the folder
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "A description of the folder")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

  public FolderDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the folder
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the folder")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public FolderDto parentId(String parentId) {
    this.parentId = parentId;
    return this;
  }

   /**
   * The ID of the folder to which this folder belongs. This can be null if the folder is not in another folder.
   * @return parentId
  **/
  @ApiModelProperty(example = "null", value = "The ID of the folder to which this folder belongs. This can be null if the folder is not in another folder.")
  public String getParentId() {
    return parentId;
  }

  public void setParentId(String parentId) {
    this.parentId = parentId;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FolderDto folderDto = (FolderDto) o;
    return Objects.equals(this.created, folderDto.created) &&
        Objects.equals(this.description, folderDto.description) &&
        Objects.equals(this.id, folderDto.id) &&
        Objects.equals(this.name, folderDto.name) &&
        Objects.equals(this.parentId, folderDto.parentId) &&
        Objects.equals(this.updated, folderDto.updated) &&
        Objects.equals(this.userId, folderDto.userId) &&
        Objects.equals(this.version, folderDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, description, id, name, parentId, updated, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FolderDto {\n");
    
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    parentId: ").append(toIndentedString(parentId)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

