/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.joda.time.DateTime;


/**
 * PivotViewDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class PivotViewDto   {
  @SerializedName("additionalMeta")
  private Map<String, Object> additionalMeta = new HashMap<String, Object>();

  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("parentId")
  private String parentId = null;

  @SerializedName("queryId")
  private String queryId = null;

  @SerializedName("queryResultId")
  private String queryResultId = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

  public PivotViewDto additionalMeta(Map<String, Object> additionalMeta) {
    this.additionalMeta = additionalMeta;
    return this;
  }

  public PivotViewDto putAdditionalMetaItem(String key, Object additionalMetaItem) {
    this.additionalMeta.put(key, additionalMetaItem);
    return this;
  }

   /**
   * User-defined metadata to attach to the pivot view. This is any arbitrary JSON object and is not required.
   * @return additionalMeta
  **/
  @ApiModelProperty(example = "null", value = "User-defined metadata to attach to the pivot view. This is any arbitrary JSON object and is not required.")
  public Map<String, Object> getAdditionalMeta() {
    return additionalMeta;
  }

  public void setAdditionalMeta(Map<String, Object> additionalMeta) {
    this.additionalMeta = additionalMeta;
  }

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

  public PivotViewDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The description of the pivot view
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "The description of the pivot view")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

  public PivotViewDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the pivot view. The maximum size is 255 characters.
   * @return name
  **/
  @ApiModelProperty(example = "null", required = true, value = "Name of the pivot view. The maximum size is 255 characters.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

   /**
   * If non-null, indicates the parent of this entity. Must be modified through the folder api.
   * @return parentId
  **/
  @ApiModelProperty(example = "null", value = "If non-null, indicates the parent of this entity. Must be modified through the folder api.")
  public String getParentId() {
    return parentId;
  }

  public PivotViewDto queryId(String queryId) {
    this.queryId = queryId;
    return this;
  }

   /**
   * The query to associate with this pivot view. This value is required and cannot be updated after the pivot is created. Any attempt to update the query ID is ignored.
   * @return queryId
  **/
  @ApiModelProperty(example = "null", required = true, value = "The query to associate with this pivot view. This value is required and cannot be updated after the pivot is created. Any attempt to update the query ID is ignored.")
  public String getQueryId() {
    return queryId;
  }

  public void setQueryId(String queryId) {
    this.queryId = queryId;
  }

  public PivotViewDto queryResultId(String queryResultId) {
    this.queryResultId = queryResultId;
    return this;
  }

   /**
   * An optional query result id to associate with this pivot view. If associated, saving a pivot view will cause an existence check on the related query result.  This value is not required. The query id on the query result must match this pivot's query ID.
   * @return queryResultId
  **/
  @ApiModelProperty(example = "null", value = "An optional query result id to associate with this pivot view. If associated, saving a pivot view will cause an existence check on the related query result.  This value is not required. The query id on the query result must match this pivot's query ID.")
  public String getQueryResultId() {
    return queryResultId;
  }

  public void setQueryResultId(String queryResultId) {
    this.queryResultId = queryResultId;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PivotViewDto pivotViewDto = (PivotViewDto) o;
    return Objects.equals(this.additionalMeta, pivotViewDto.additionalMeta) &&
        Objects.equals(this.created, pivotViewDto.created) &&
        Objects.equals(this.description, pivotViewDto.description) &&
        Objects.equals(this.id, pivotViewDto.id) &&
        Objects.equals(this.name, pivotViewDto.name) &&
        Objects.equals(this.parentId, pivotViewDto.parentId) &&
        Objects.equals(this.queryId, pivotViewDto.queryId) &&
        Objects.equals(this.queryResultId, pivotViewDto.queryResultId) &&
        Objects.equals(this.updated, pivotViewDto.updated) &&
        Objects.equals(this.userId, pivotViewDto.userId) &&
        Objects.equals(this.version, pivotViewDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(additionalMeta, created, description, id, name, parentId, queryId, queryResultId, updated, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PivotViewDto {\n");
    
    sb.append("    additionalMeta: ").append(toIndentedString(additionalMeta)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    parentId: ").append(toIndentedString(parentId)).append("\n");
    sb.append("    queryId: ").append(toIndentedString(queryId)).append("\n");
    sb.append("    queryResultId: ").append(toIndentedString(queryResultId)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

