/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * QueryParameterDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class QueryParameterDto   {
  @SerializedName("alias")
  private String alias = null;

  @SerializedName("choices")
  private List<Object> choices = new ArrayList<Object>();

  @SerializedName("id")
  private String id = null;

  @SerializedName("label")
  private String label = null;

  /**
   * The mode of the query parameter
   */
  public enum ModeEnum {
    @SerializedName("scalar")
    SCALAR("scalar"),
    
    @SerializedName("singleSelect")
    SINGLESELECT("singleSelect"),
    
    @SerializedName("multiSelect")
    MULTISELECT("multiSelect"),
    
    @SerializedName("reference")
    REFERENCE("reference");

    private String value;

    ModeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("mode")
  private ModeEnum mode = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("overridable")
  private Boolean overridable = null;

  @SerializedName("reference")
  private Object reference = null;

  @SerializedName("selectListId")
  private String selectListId = null;

  /**
   * The type of the query parameter
   */
  public enum TypeEnum {
    @SerializedName("string")
    STRING("string"),
    
    @SerializedName("bytes")
    BYTES("bytes"),
    
    @SerializedName("integer")
    INTEGER("integer"),
    
    @SerializedName("float")
    FLOAT("float"),
    
    @SerializedName("boolean")
    BOOLEAN("boolean"),
    
    @SerializedName("timestamp")
    TIMESTAMP("timestamp"),
    
    @SerializedName("date")
    DATE("date"),
    
    @SerializedName("time")
    TIME("time"),
    
    @SerializedName("datetime")
    DATETIME("datetime"),
    
    @SerializedName("global_parameter")
    GLOBAL_PARAMETER("global_parameter"),
    
    @SerializedName("nested_query_parameter")
    NESTED_QUERY_PARAMETER("nested_query_parameter");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("value")
  private Object value = null;

  public QueryParameterDto alias(String alias) {
    this.alias = alias;
    return this;
  }

   /**
   * The alias of the query parameter, used to avoid name collisions for nested query parameter references
   * @return alias
  **/
  @ApiModelProperty(example = "null", value = "The alias of the query parameter, used to avoid name collisions for nested query parameter references")
  public String getAlias() {
    return alias;
  }

  public void setAlias(String alias) {
    this.alias = alias;
  }

  public QueryParameterDto choices(List<Object> choices) {
    this.choices = choices;
    return this;
  }

  public QueryParameterDto addChoicesItem(Object choicesItem) {
    this.choices.add(choicesItem);
    return this;
  }

   /**
   * If the query parameter is of type select, this is a list of possible choices. This  is read only and is for listing and viewing reports to help the user.
   * @return choices
  **/
  @ApiModelProperty(example = "null", value = "If the query parameter is of type select, this is a list of possible choices. This  is read only and is for listing and viewing reports to help the user.")
  public List<Object> getChoices() {
    return choices;
  }

  public void setChoices(List<Object> choices) {
    this.choices = choices;
  }

  public QueryParameterDto id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The entity's unique identifier, set if it is a reference kind.
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier, set if it is a reference kind.")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public QueryParameterDto label(String label) {
    this.label = label;
    return this;
  }

   /**
   * The label for the query parameter
   * @return label
  **/
  @ApiModelProperty(example = "null", value = "The label for the query parameter")
  public String getLabel() {
    return label;
  }

  public void setLabel(String label) {
    this.label = label;
  }

  public QueryParameterDto mode(ModeEnum mode) {
    this.mode = mode;
    return this;
  }

   /**
   * The mode of the query parameter
   * @return mode
  **/
  @ApiModelProperty(example = "null", value = "The mode of the query parameter")
  public ModeEnum getMode() {
    return mode;
  }

  public void setMode(ModeEnum mode) {
    this.mode = mode;
  }

  public QueryParameterDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the query parameter
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the query parameter")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

   /**
   * Whether the parameter can be overridden, defaults to true.
   * @return overridable
  **/
  @ApiModelProperty(example = "false", value = "Whether the parameter can be overridden, defaults to true.")
  public Boolean getOverridable() {
    return overridable;
  }

  public QueryParameterDto reference(Object reference) {
    this.reference = reference;
    return this;
  }

   /**
   * The hydrated reference object
   * @return reference
  **/
  @ApiModelProperty(example = "null", value = "The hydrated reference object")
  public Object getReference() {
    return reference;
  }

  public void setReference(Object reference) {
    this.reference = reference;
  }

  public QueryParameterDto selectListId(String selectListId) {
    this.selectListId = selectListId;
    return this;
  }

   /**
   * If mode is select, this must be populated and is a reference to a select list from which choices will be derived.
   * @return selectListId
  **/
  @ApiModelProperty(example = "null", value = "If mode is select, this must be populated and is a reference to a select list from which choices will be derived.")
  public String getSelectListId() {
    return selectListId;
  }

  public void setSelectListId(String selectListId) {
    this.selectListId = selectListId;
  }

  public QueryParameterDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * The type of the query parameter
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "The type of the query parameter")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public QueryParameterDto value(Object value) {
    this.value = value;
    return this;
  }

   /**
   * The value of the query parameter
   * @return value
  **/
  @ApiModelProperty(example = "null", value = "The value of the query parameter")
  public Object getValue() {
    return value;
  }

  public void setValue(Object value) {
    this.value = value;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryParameterDto queryParameterDto = (QueryParameterDto) o;
    return Objects.equals(this.alias, queryParameterDto.alias) &&
        Objects.equals(this.choices, queryParameterDto.choices) &&
        Objects.equals(this.id, queryParameterDto.id) &&
        Objects.equals(this.label, queryParameterDto.label) &&
        Objects.equals(this.mode, queryParameterDto.mode) &&
        Objects.equals(this.name, queryParameterDto.name) &&
        Objects.equals(this.overridable, queryParameterDto.overridable) &&
        Objects.equals(this.reference, queryParameterDto.reference) &&
        Objects.equals(this.selectListId, queryParameterDto.selectListId) &&
        Objects.equals(this.type, queryParameterDto.type) &&
        Objects.equals(this.value, queryParameterDto.value);
  }

  @Override
  public int hashCode() {
    return Objects.hash(alias, choices, id, label, mode, name, overridable, reference, selectListId, type, value);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryParameterDto {\n");
    
    sb.append("    alias: ").append(toIndentedString(alias)).append("\n");
    sb.append("    choices: ").append(toIndentedString(choices)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    label: ").append(toIndentedString(label)).append("\n");
    sb.append("    mode: ").append(toIndentedString(mode)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    overridable: ").append(toIndentedString(overridable)).append("\n");
    sb.append("    reference: ").append(toIndentedString(reference)).append("\n");
    sb.append("    selectListId: ").append(toIndentedString(selectListId)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

