/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.ColumnInfoDto;
import io.swagger.client.model.QueryDto;
import io.swagger.client.model.QueryParameterDto;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.joda.time.DateTime;


/**
 * QueryResultDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class QueryResultDto   {
  @SerializedName("bytesScanned")
  private Long bytesScanned = null;

  @SerializedName("columns")
  private List<ColumnInfoDto> columns = new ArrayList<ColumnInfoDto>();

  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("duration")
  private Long duration = null;

  @SerializedName("error")
  private String error = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("isExplain")
  private Boolean isExplain = null;

  @SerializedName("parameters")
  private Map<String, Object> parameters = new HashMap<String, Object>();

  /**
   * The current status of the pivot execution
   */
  public enum PivotStatusEnum {
    @SerializedName("NOT_STARTED")
    NOT_STARTED("NOT_STARTED"),
    
    @SerializedName("RUNNING")
    RUNNING("RUNNING"),
    
    @SerializedName("COMPLETE")
    COMPLETE("COMPLETE"),
    
    @SerializedName("ERROR")
    ERROR("ERROR"),
    
    @SerializedName("CANCELLED")
    CANCELLED("CANCELLED"),
    
    @SerializedName("RUNNING_QUERY")
    RUNNING_QUERY("RUNNING_QUERY"),
    
    @SerializedName("PIVOT_QUEUED")
    PIVOT_QUEUED("PIVOT_QUEUED"),
    
    @SerializedName("RUNNING_PIVOT")
    RUNNING_PIVOT("RUNNING_PIVOT"),
    
    @SerializedName("QUERY_COMPLETE")
    QUERY_COMPLETE("QUERY_COMPLETE"),
    
    @SerializedName("NOT_APPLICABLE")
    NOT_APPLICABLE("NOT_APPLICABLE"),
    
    @SerializedName("PIVOT_ERROR")
    PIVOT_ERROR("PIVOT_ERROR");

    private String value;

    PivotStatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("pivotStatus")
  private PivotStatusEnum pivotStatus = null;

  @SerializedName("queryDto")
  private QueryDto queryDto = null;

  @SerializedName("queryId")
  private String queryId = null;

  @SerializedName("queryParameters")
  private List<QueryParameterDto> queryParameters = new ArrayList<QueryParameterDto>();

  @SerializedName("queryText")
  private String queryText = null;

  @SerializedName("rowsReturned")
  private Long rowsReturned = null;

  @SerializedName("size")
  private Long size = null;

  /**
   * The current status of the query execution
   */
  public enum StatusEnum {
    @SerializedName("NOT_STARTED")
    NOT_STARTED("NOT_STARTED"),
    
    @SerializedName("RUNNING")
    RUNNING("RUNNING"),
    
    @SerializedName("COMPLETE")
    COMPLETE("COMPLETE"),
    
    @SerializedName("ERROR")
    ERROR("ERROR"),
    
    @SerializedName("CANCELLED")
    CANCELLED("CANCELLED");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("status")
  private StatusEnum status = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

   /**
   * The number of bytes scanned
   * @return bytesScanned
  **/
  @ApiModelProperty(example = "null", value = "The number of bytes scanned")
  public Long getBytesScanned() {
    return bytesScanned;
  }

  public QueryResultDto columns(List<ColumnInfoDto> columns) {
    this.columns = columns;
    return this;
  }

  public QueryResultDto addColumnsItem(ColumnInfoDto columnsItem) {
    this.columns.add(columnsItem);
    return this;
  }

   /**
   * If the query has successfully completed, contains a list of columns and their associated computed types from the query.
   * @return columns
  **/
  @ApiModelProperty(example = "null", value = "If the query has successfully completed, contains a list of columns and their associated computed types from the query.")
  public List<ColumnInfoDto> getColumns() {
    return columns;
  }

  public void setColumns(List<ColumnInfoDto> columns) {
    this.columns = columns;
  }

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The duration of time it took to execute the query
   * @return duration
  **/
  @ApiModelProperty(example = "null", value = "The duration of time it took to execute the query")
  public Long getDuration() {
    return duration;
  }

   /**
   * If an error was encountered during the query, this field will be populated with error text.
   * @return error
  **/
  @ApiModelProperty(example = "null", value = "If an error was encountered during the query, this field will be populated with error text.")
  public String getError() {
    return error;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

  public QueryResultDto isExplain(Boolean isExplain) {
    this.isExplain = isExplain;
    return this;
  }

   /**
   * Determines if this query is to be explained and not executed
   * @return isExplain
  **/
  @ApiModelProperty(example = "false", value = "Determines if this query is to be explained and not executed")
  public Boolean getIsExplain() {
    return isExplain;
  }

  public void setIsExplain(Boolean isExplain) {
    this.isExplain = isExplain;
  }

  public QueryResultDto parameters(Map<String, Object> parameters) {
    this.parameters = parameters;
    return this;
  }

  public QueryResultDto putParametersItem(String key, Object parametersItem) {
    this.parameters.put(key, parametersItem);
    return this;
  }

   /**
   * The query parameter map
   * @return parameters
  **/
  @ApiModelProperty(example = "null", value = "The query parameter map")
  public Map<String, Object> getParameters() {
    return parameters;
  }

  public void setParameters(Map<String, Object> parameters) {
    this.parameters = parameters;
  }

   /**
   * The current status of the pivot execution
   * @return pivotStatus
  **/
  @ApiModelProperty(example = "null", value = "The current status of the pivot execution")
  public PivotStatusEnum getPivotStatus() {
    return pivotStatus;
  }

  public QueryResultDto queryDto(QueryDto queryDto) {
    this.queryDto = queryDto;
    return this;
  }

   /**
   * Associated queryDto
   * @return queryDto
  **/
  @ApiModelProperty(example = "null", value = "Associated queryDto")
  public QueryDto getQueryDto() {
    return queryDto;
  }

  public void setQueryDto(QueryDto queryDto) {
    this.queryDto = queryDto;
  }

  public QueryResultDto queryId(String queryId) {
    this.queryId = queryId;
    return this;
  }

   /**
   * The identifier of the original query
   * @return queryId
  **/
  @ApiModelProperty(example = "null", value = "The identifier of the original query")
  public String getQueryId() {
    return queryId;
  }

  public void setQueryId(String queryId) {
    this.queryId = queryId;
  }

  public QueryResultDto queryParameters(List<QueryParameterDto> queryParameters) {
    this.queryParameters = queryParameters;
    return this;
  }

  public QueryResultDto addQueryParametersItem(QueryParameterDto queryParametersItem) {
    this.queryParameters.add(queryParametersItem);
    return this;
  }

   /**
   * Contains the parameters available to the query at the time it was run. This allows consumers to go back in time and view the state of the query at runtime. For older query runs, this value may not be populated.
   * @return queryParameters
  **/
  @ApiModelProperty(example = "null", value = "Contains the parameters available to the query at the time it was run. This allows consumers to go back in time and view the state of the query at runtime. For older query runs, this value may not be populated.")
  public List<QueryParameterDto> getQueryParameters() {
    return queryParameters;
  }

  public void setQueryParameters(List<QueryParameterDto> queryParameters) {
    this.queryParameters = queryParameters;
  }

   /**
   * Get queryText
   * @return queryText
  **/
  @ApiModelProperty(example = "null", value = "")
  public String getQueryText() {
    return queryText;
  }

   /**
   * Contains the number of rows returned from the query.
   * @return rowsReturned
  **/
  @ApiModelProperty(example = "null", value = "Contains the number of rows returned from the query.")
  public Long getRowsReturned() {
    return rowsReturned;
  }

   /**
   * Contains the size of the query results in bytes. This can be used to determine how best to download the file and if it's reasonable to open it in a browser or other application. This may be 0 if there are no results or the query results were gathered before we started collecting this metric.
   * @return size
  **/
  @ApiModelProperty(example = "null", value = "Contains the size of the query results in bytes. This can be used to determine how best to download the file and if it's reasonable to open it in a browser or other application. This may be 0 if there are no results or the query results were gathered before we started collecting this metric.")
  public Long getSize() {
    return size;
  }

   /**
   * The current status of the query execution
   * @return status
  **/
  @ApiModelProperty(example = "null", value = "The current status of the query execution")
  public StatusEnum getStatus() {
    return status;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryResultDto queryResultDto = (QueryResultDto) o;
    return Objects.equals(this.bytesScanned, queryResultDto.bytesScanned) &&
        Objects.equals(this.columns, queryResultDto.columns) &&
        Objects.equals(this.created, queryResultDto.created) &&
        Objects.equals(this.duration, queryResultDto.duration) &&
        Objects.equals(this.error, queryResultDto.error) &&
        Objects.equals(this.id, queryResultDto.id) &&
        Objects.equals(this.isExplain, queryResultDto.isExplain) &&
        Objects.equals(this.parameters, queryResultDto.parameters) &&
        Objects.equals(this.pivotStatus, queryResultDto.pivotStatus) &&
        Objects.equals(this.queryDto, queryResultDto.queryDto) &&
        Objects.equals(this.queryId, queryResultDto.queryId) &&
        Objects.equals(this.queryParameters, queryResultDto.queryParameters) &&
        Objects.equals(this.queryText, queryResultDto.queryText) &&
        Objects.equals(this.rowsReturned, queryResultDto.rowsReturned) &&
        Objects.equals(this.size, queryResultDto.size) &&
        Objects.equals(this.status, queryResultDto.status) &&
        Objects.equals(this.updated, queryResultDto.updated) &&
        Objects.equals(this.userId, queryResultDto.userId) &&
        Objects.equals(this.version, queryResultDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(bytesScanned, columns, created, duration, error, id, isExplain, parameters, pivotStatus, queryDto, queryId, queryParameters, queryText, rowsReturned, size, status, updated, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryResultDto {\n");
    
    sb.append("    bytesScanned: ").append(toIndentedString(bytesScanned)).append("\n");
    sb.append("    columns: ").append(toIndentedString(columns)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    duration: ").append(toIndentedString(duration)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    isExplain: ").append(toIndentedString(isExplain)).append("\n");
    sb.append("    parameters: ").append(toIndentedString(parameters)).append("\n");
    sb.append("    pivotStatus: ").append(toIndentedString(pivotStatus)).append("\n");
    sb.append("    queryDto: ").append(toIndentedString(queryDto)).append("\n");
    sb.append("    queryId: ").append(toIndentedString(queryId)).append("\n");
    sb.append("    queryParameters: ").append(toIndentedString(queryParameters)).append("\n");
    sb.append("    queryText: ").append(toIndentedString(queryText)).append("\n");
    sb.append("    rowsReturned: ").append(toIndentedString(rowsReturned)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

