/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.ConnectionRunDto;
import java.util.ArrayList;
import java.util.List;
import org.joda.time.DateTime;


/**
 * RefreshBatchDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class RefreshBatchDto   {
  @SerializedName("batchRefreshId")
  private String batchRefreshId = null;

  @SerializedName("childRefreshes")
  private List<ConnectionRunDto> childRefreshes = new ArrayList<ConnectionRunDto>();

  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("createdBy")
  private String createdBy = null;

  /**
   * The run status of the destination
   */
  public enum DestinationStatusEnum {
    @SerializedName("not_started")
    NOT_STARTED("not_started"),
    
    @SerializedName("running")
    RUNNING("running"),
    
    @SerializedName("complete")
    COMPLETE("complete"),
    
    @SerializedName("error")
    ERROR("error"),
    
    @SerializedName("cancelled")
    CANCELLED("cancelled");

    private String value;

    DestinationStatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("destinationStatus")
  private DestinationStatusEnum destinationStatus = null;

  @SerializedName("error")
  private String error = null;

  /**
   * The run status of the source
   */
  public enum SourceStatusEnum {
    @SerializedName("not_started")
    NOT_STARTED("not_started"),
    
    @SerializedName("running")
    RUNNING("running"),
    
    @SerializedName("complete")
    COMPLETE("complete"),
    
    @SerializedName("error")
    ERROR("error"),
    
    @SerializedName("cancelled")
    CANCELLED("cancelled");

    private String value;

    SourceStatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("sourceStatus")
  private SourceStatusEnum sourceStatus = null;

  @SerializedName("updated")
  private DateTime updated = null;

   /**
   * The unique ID of the batch
   * @return batchRefreshId
  **/
  @ApiModelProperty(example = "null", value = "The unique ID of the batch")
  public String getBatchRefreshId() {
    return batchRefreshId;
  }

  public RefreshBatchDto childRefreshes(List<ConnectionRunDto> childRefreshes) {
    this.childRefreshes = childRefreshes;
    return this;
  }

  public RefreshBatchDto addChildRefreshesItem(ConnectionRunDto childRefreshesItem) {
    this.childRefreshes.add(childRefreshesItem);
    return this;
  }

   /**
   * The list of jobs initiated by the batch
   * @return childRefreshes
  **/
  @ApiModelProperty(example = "null", value = "The list of jobs initiated by the batch")
  public List<ConnectionRunDto> getChildRefreshes() {
    return childRefreshes;
  }

  public void setChildRefreshes(List<ConnectionRunDto> childRefreshes) {
    this.childRefreshes = childRefreshes;
  }

   /**
   * When the batch was created, as a datetime
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the batch was created, as a datetime")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The ID of the user that created the batch
   * @return createdBy
  **/
  @ApiModelProperty(example = "null", value = "The ID of the user that created the batch")
  public String getCreatedBy() {
    return createdBy;
  }

   /**
   * The run status of the destination
   * @return destinationStatus
  **/
  @ApiModelProperty(example = "null", value = "The run status of the destination")
  public DestinationStatusEnum getDestinationStatus() {
    return destinationStatus;
  }

   /**
   * Any error encountered while initiating the batch
   * @return error
  **/
  @ApiModelProperty(example = "null", value = "Any error encountered while initiating the batch")
  public String getError() {
    return error;
  }

   /**
   * The run status of the source
   * @return sourceStatus
  **/
  @ApiModelProperty(example = "null", value = "The run status of the source")
  public SourceStatusEnum getSourceStatus() {
    return sourceStatus;
  }

   /**
   * When the batch was updated, as a datetime
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the batch was updated, as a datetime")
  public DateTime getUpdated() {
    return updated;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RefreshBatchDto refreshBatchDto = (RefreshBatchDto) o;
    return Objects.equals(this.batchRefreshId, refreshBatchDto.batchRefreshId) &&
        Objects.equals(this.childRefreshes, refreshBatchDto.childRefreshes) &&
        Objects.equals(this.created, refreshBatchDto.created) &&
        Objects.equals(this.createdBy, refreshBatchDto.createdBy) &&
        Objects.equals(this.destinationStatus, refreshBatchDto.destinationStatus) &&
        Objects.equals(this.error, refreshBatchDto.error) &&
        Objects.equals(this.sourceStatus, refreshBatchDto.sourceStatus) &&
        Objects.equals(this.updated, refreshBatchDto.updated);
  }

  @Override
  public int hashCode() {
    return Objects.hash(batchRefreshId, childRefreshes, created, createdBy, destinationStatus, error, sourceStatus, updated);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RefreshBatchDto {\n");
    
    sb.append("    batchRefreshId: ").append(toIndentedString(batchRefreshId)).append("\n");
    sb.append("    childRefreshes: ").append(toIndentedString(childRefreshes)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    createdBy: ").append(toIndentedString(createdBy)).append("\n");
    sb.append("    destinationStatus: ").append(toIndentedString(destinationStatus)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("    sourceStatus: ").append(toIndentedString(sourceStatus)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

