/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.FileMetaDto;
import java.util.ArrayList;
import java.util.List;


/**
 * ValidateFilesDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-11-23T18:10:28.150Z")
public class ValidateFilesDto   {
  @SerializedName("deletedFiles")
  private List<FileMetaDto> deletedFiles = new ArrayList<FileMetaDto>();

  @SerializedName("repairedFiles")
  private List<FileMetaDto> repairedFiles = new ArrayList<FileMetaDto>();

  public ValidateFilesDto deletedFiles(List<FileMetaDto> deletedFiles) {
    this.deletedFiles = deletedFiles;
    return this;
  }

  public ValidateFilesDto addDeletedFilesItem(FileMetaDto deletedFilesItem) {
    this.deletedFiles.add(deletedFilesItem);
    return this;
  }

   /**
   * A list of files that were deleted during the validation because not enough information was available to repair them. These files will no longer be available via the endpoint and will not be included in queries.
   * @return deletedFiles
  **/
  @ApiModelProperty(example = "null", value = "A list of files that were deleted during the validation because not enough information was available to repair them. These files will no longer be available via the endpoint and will not be included in queries.")
  public List<FileMetaDto> getDeletedFiles() {
    return deletedFiles;
  }

  public void setDeletedFiles(List<FileMetaDto> deletedFiles) {
    this.deletedFiles = deletedFiles;
  }

  public ValidateFilesDto repairedFiles(List<FileMetaDto> repairedFiles) {
    this.repairedFiles = repairedFiles;
    return this;
  }

  public ValidateFilesDto addRepairedFilesItem(FileMetaDto repairedFilesItem) {
    this.repairedFiles.add(repairedFilesItem);
    return this;
  }

   /**
   * A list of files that were modified during the validation and will continue to be visible and to be usable in the account.
   * @return repairedFiles
  **/
  @ApiModelProperty(example = "null", value = "A list of files that were modified during the validation and will continue to be visible and to be usable in the account.")
  public List<FileMetaDto> getRepairedFiles() {
    return repairedFiles;
  }

  public void setRepairedFiles(List<FileMetaDto> repairedFiles) {
    this.repairedFiles = repairedFiles;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ValidateFilesDto validateFilesDto = (ValidateFilesDto) o;
    return Objects.equals(this.deletedFiles, validateFilesDto.deletedFiles) &&
        Objects.equals(this.repairedFiles, validateFilesDto.repairedFiles);
  }

  @Override
  public int hashCode() {
    return Objects.hash(deletedFiles, repairedFiles);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ValidateFilesDto {\n");
    
    sb.append("    deletedFiles: ").append(toIndentedString(deletedFiles)).append("\n");
    sb.append("    repairedFiles: ").append(toIndentedString(repairedFiles)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

