/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.PivotViewDto;
import io.swagger.client.model.BaseResponseOfPivotViewDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.BaseResponseOfTokenDto;
import io.swagger.client.model.PagedResponseOfPivotViewDto;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for PivotViewManagementApi
 */
public class PivotViewManagementApiTest {

    private final PivotViewManagementApi api = new PivotViewManagementApi();

    
    /**
     * Create a new pivot view
     *
     * Creates a view from the provided information. Currently, persists the provided &#x60;additionalMetadata&#x60; field, which can store an arbitrary JSON definition of a pivot table view. This pivot table must be associated with a query, and can optionally be associated with a query result. When a query is deleted, its associated views are also deleted.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createPivotViewUsingPOSTTest() throws ApiException {
        PivotViewDto pivotViewDto = null;
        // BaseResponseOfPivotViewDto response = api.createPivotViewUsingPOST(pivotViewDto);

        // TODO: test validations
    }
    
    /**
     * Delete a single pivot view
     *
     * Deletes a view that matches the provided ID.  This is an administrative method and should be assumed a hard-delete, given no capability to restore a deleted view is available.  A no-op if no such view exists.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deletePivotViewUsingDELETETest() throws ApiException {
        String pivotViewId = null;
        // BaseResponseOfstring response = api.deletePivotViewUsingDELETE(pivotViewId);

        // TODO: test validations
    }
    
    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
     *
     * 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void downloadPivotViewTokenUsingGETTest() throws ApiException {
        String pivotViewId = null;
        // BaseResponseOfTokenDto response = api.downloadPivotViewTokenUsingGET(pivotViewId);

        // TODO: test validations
    }
    
    /**
     * This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
     *
     * 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void downloadPivotViewUsingGETTest() throws ApiException {
        String pivotViewId = null;
        // byte[] response = api.downloadPivotViewUsingGET(pivotViewId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a single pivot view
     *
     * Returns a view with the provided ID, or a 404 if no view matches the ID.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getPivotViewUsingGETTest() throws ApiException {
        String pivotViewId = null;
        // BaseResponseOfPivotViewDto response = api.getPivotViewUsingGET(pivotViewId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a list of pivot views
     *
     * Returns a paged list of views in the workspace of the request. If queryId is provided, the results are limited to only views associated with the query ID.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listPivotViewsUsingGETTest() throws ApiException {
        String queryId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfPivotViewDto response = api.listPivotViewsUsingGET(queryId, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Update a single pivot view
     *
     * Updates the view that matches the provided ID with the details provided in the body. The associated query can&#39;t be updated, so providing the query ID has no effect.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updatePivotViewUsingPUTTest() throws ApiException {
        String pivotViewId = null;
        PivotViewDto pivotViewDto = null;
        // BaseResponseOfPivotViewDto response = api.updatePivotViewUsingPUT(pivotViewId, pivotViewDto);

        // TODO: test validations
    }
    
}
