/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.TableDto;
import io.swagger.client.model.BaseResponseOfTableDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.PagedResponseOfQueryDto;
import io.swagger.client.model.BaseResponseOfImportInfoDto;
import io.swagger.client.model.PagedResponseOfTableDto;
import io.swagger.client.model.ImportDto;
import io.swagger.client.model.BaseResponseOfFileMetaDto;
import io.swagger.client.model.ImportFromSpreadsheetDto;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for TableManagementApi
 */
public class TableManagementApiTest {

    private final TableManagementApi api = new TableManagementApi();

    
    /**
     * Create a new table
     *
     * Creates a table in the database with the specified schema. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createTableUsingPOSTTest() throws ApiException {
        TableDto body = null;
        // BaseResponseOfTableDto response = api.createTableUsingPOST(body);

        // TODO: test validations
    }
    
    /**
     * Delete a single table
     *
     * Soft-deletes the table with the provided ID.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteTableUsingDELETETest() throws ApiException {
        String tableId = null;
        // BaseResponseOfstring response = api.deleteTableUsingDELETE(tableId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a list of dependents
     *
     * Returns a list of all queries that use the table with provided ID as a datasource. If a shared table, this may include queries outside of the current OAuth context.  Permission is checked only for the table ID provided, _not_ on the returned list of queries.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getDependentsUsingGETTest() throws ApiException {
        String tableId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfQueryDto response = api.getDependentsUsingGET(tableId, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Retrieve import information
     *
     * Returns information around imported files for a table.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImportInfoUsingGETTest() throws ApiException {
        String tableId = null;
        // BaseResponseOfImportInfoDto response = api.getImportInfoUsingGET(tableId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a single table
     *
     * Returns a table with the provided ID, or a 404 if no such table is found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getTableUsingGETTest() throws ApiException {
        String tableId = null;
        // BaseResponseOfTableDto response = api.getTableUsingGET(tableId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a list of tables
     *
     * Returns all tables available in the workspace.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getTablesUsingGETTest() throws ApiException {
        Boolean includeShared = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfTableDto response = api.getTablesUsingGET(includeShared, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Import a single file
     *
     * Imports the provided file into the associated table, and immediately returns a file meta object with an ID that can be used to poll the file controller for status.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void importFileUsingPOSTTest() throws ApiException {
        String tableId = null;
        ImportDto importDto = null;
        // BaseResponseOfFileMetaDto response = api.importFileUsingPOST(tableId, importDto);

        // TODO: test validations
    }
    
    /**
     * Import from spreadsheets
     *
     * Imports spreadsheet data and immediately returns a file meta result. This DTO has an ID, which can be used to poll on status via the file controller.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void importFromSpreadsheetsUsingPOSTTest() throws ApiException {
        String tableId = null;
        ImportFromSpreadsheetDto importFromSpreadsheetDto = null;
        // BaseResponseOfFileMetaDto response = api.importFromSpreadsheetsUsingPOST(tableId, importFromSpreadsheetDto);

        // TODO: test validations
    }
    
    /**
     * Unimport a single file
     *
     * Unimports the provided file from the provided table. Returns a 409 if the file is not in an imported state, or a 404 if the file can&#39;t be found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void unimportFileUsingDELETETest() throws ApiException {
        String tableId = null;
        String fileId = null;
        String force = null;
        // BaseResponseOfFileMetaDto response = api.unimportFileUsingDELETE(tableId, fileId, force);

        // TODO: test validations
    }
    
    /**
     * Update a single table
     *
     * Updates an existing table with the provided information. Include all user-defined table columns with the request. For type, specify either a dimension or data table. In the interface, data tables appear as fact tables.  * If the table has no imported data, user-defined columns not included with the request are deleted, and columns are sorted according to their order in the request.  * If the table has imported data, any columns with names not already in the table are considered new. This equality check is case-insensitive. Any new columns appear after other user-defined columns, but before any meta columns, which start with &#x60;_&#x60;.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateTableUsingPUTTest() throws ApiException {
        TableDto tableDto = null;
        String tableId = null;
        // BaseResponseOfTableDto response = api.updateTableUsingPUT(tableDto, tableId);

        // TODO: test validations
    }
    
}
